'use strict';

(function ($) {

    var $window = $(window);

    $.fn.center = function () {
        this.css("position","absolute");
        this.css("top", ( jQuery(window).height() - this.height() ) / 2+jQuery(window).scrollTop() + "px");
        this.css("left", ( jQuery(window).width() - this.width() ) / 2+jQuery(window).scrollLeft() + "px");
        return this;
    }

    $(document.body).on('tokenize:tokens:add', '.api-field', function(e, value, text) {

        // if (!window.apiFieldsOnLoad) {
        //     console.log('tokenize:tokens:add - Start');
        // }

        var activeField = $(document.body).find('.tokenize.active');

        updateFieldDatApiOption (activeField, function() {
            // console.log('tokenize:tokens:add - End');
            // console.log('================');
        });

        if (!window.apiFieldsOnLoad) {
            maybeUpdateTagsCloud(activeField);
        }
    });

    $(document.body).on('tokenize:dropdown:fill', '.api-field', function(e, items) {

        // if (!window.apiFieldsOnLoad) {
        //     console.log('tokenize:dropdown:fill - Start');
        // }

        var activeField = $(document.body).find('.tokenize.active');

        updateFieldDatApiOption (activeField, function() {
            // console.log('tokenize:tokens:fill - End');
            // console.log('================');
        });
    });

    $(document.body).on('tokenize:tokens:remove', '.api-field', function(e, value){

        // if (!window.apiFieldsOnLoad) {
        //     console.log('tokenize:tokens:remove - Start');
        // }

        var activeField = $(document.body).find('.tokenize.active');

        updateFieldDatApiOption (activeField, function() {
            // console.log('tokenize:tokens:remove - End');
            // console.log('================');
        });

        if (!window.apiFieldsOnLoad) {
            maybeUpdateTagsCloud(activeField);
        }
    });

    $(document.body).on('tokenize:paste', '.api-field', function(e, items){

        // if (!window.apiFieldsOnLoad) {
        //     console.log('tokenize:paste - Start');
        // }

        var activeField = $(document.body).find('.tokenize.active');

        updateFieldDatApiOption (activeField, function() {
            // console.log('tokenize:tokens:paste - End');
            // console.log('================');
        });
    });

    function maybeUpdateTagsCloud(activeField) {
        var activeFieldBody = activeField.parents('.api_field_body');
        var activeFieldSelect = activeFieldBody.find('select.api-field');
        var activeFieldName = activeFieldSelect.attr('name');
        var currentMap = compileMapToAPIObject();

        if('api_email' === activeFieldName) {
            $('.accordion-body.api-processing-holder .api-spinner-holder').addClass('api-processing');

            var tableColumns = currentMap.fields.api_email.table_columns;
            var email = '';

            if (tableColumns.length > 0) {
                var option = $('.available_option label[data-table-column="' + tableColumns[0] + '"]');

                if (option.length > 0) {
                    $.each(option, function (index, opt) {
                        email = $(opt).data('value');
                    });
                }
            }

            setTimeout(function() {
                getUsersTagsFromKlickTipp(email, function() {
                    loadPossibleTagsCloud(email, function() {
                        $('.accordion-body.api-processing-holder .api-spinner-holder').removeClass('api-processing');
                    });
                });
            }, 800);
        }
    }

    $(document.body).on('tokenize:dropdown:fill', '.options_where', function(e, items){
        //console.log('tokenize:dropdown:fill .options_where');

        if (!window.possibleTagsOnLoad) {
            setTimeout(function() {
                updatePossibleTagsOnChange();
            }, 800);
        }
    });

    $(document.body).on('tokenize:tokens:remove', '.options_where', function(e, items){
        //console.log('tokenize:tokens:remove .options_where');

        if (!window.possibleTagsOnLoad) {
            setTimeout(function() {
                updatePossibleTagsOnChange();
            }, 800);
        }
    });

    $(document.body).on('tokenize:tokens:add', '.options_where', function(e, items){
        //console.log('tokenize:tokens:add .options_where');

        if (!window.possibleTagsOnLoad) {
            setTimeout(function() {
                updatePossibleTagsOnChange();
            }, 800);
        }
    });

    $(document.body).on('tokenize:dropdown:fill', '.options-list', function(e, items){
        //console.log('tokenize:dropdown:fill .options-list');

        if (!window.possibleTagsOnLoad) {
            setTimeout(function() {
                updatePossibleTagsOnChange();
            }, 800);
        }
    });

    $(document.body).on('tokenize:tokens:remove', '.options-list', function(e, items){
        //console.log('tokenize:tokens:remove .options-list');

        if (!window.possibleTagsOnLoad) {
            setTimeout(function() {
                updatePossibleTagsOnChange();
            }, 800);
        }
    });

    $(document.body).on('tokenize:tokens:add', '.options-list', function(e, items){
        //console.log('tokenize:tokens:add .options-list');

        if (!window.possibleTagsOnLoad) {
            setTimeout(function() {
                updatePossibleTagsOnChange();
            }, 800);
        }
    });

    $(document.body).on('tokenize:dropdown:fill', '.options-concat-list', function(e, items){
        //console.log('tokenize:dropdown:fill .options-concat-list');

        if (!window.possibleTagsOnLoad) {
            setTimeout(function() {
                updatePossibleTagsOnChange();
            }, 800);
        }
    });

    $(document.body).on('tokenize:tokens:remove', '.options-concat-list', function(e, items){
        //console.log('tokenize:tokens:remove .options-concat-list');

        if (!window.possibleTagsOnLoad) {
            setTimeout(function() {
                updatePossibleTagsOnChange();
            }, 800);
        }
    });

    $(document.body).on('tokenize:tokens:add', '.options-concat-list', function(e, items){
        //console.log('tokenize:tokens:add .options-concat-list');

        if (!window.possibleTagsOnLoad) {
            setTimeout(function() {
                updatePossibleTagsOnChange();
            }, 800);
        }
    });

    $(document.body).on('click', '.accordion-header', function() {
        var controller = $(this),
            panel = controller.next('.accordion-body'),
            group = controller.parent('.accordion-group');

        group.find('.accordion-body').each(function () {
            $(this).hide();
        });

        if (controller.hasClass('active')) {
            controller.removeClass('active');
            panel.hide();
        } else {
            group.find('.accordion-header').each(function () {
                $(this).removeClass('active');
            });

            controller.addClass('active');
            panel.show();
        }
    });

    $(document.body).on('click', '.options-buttons-wrapper > .prev, .options-buttons-wrapper > .next', nextOptionsPage);

    $(document.body).on('click', '.available_options .available_option', function() {
        var selectAvailableOption = $(this);
        var optionAvailableText = '';
        var activeField = $(document.body).find('.tokenize.active');

        if(activeField.length === 0)
            return 0;

        if (activeField.parents('.conditions-list').length || activeField.parents('.connected-options-wrapper').length) {
            optionAvailableText = selectAvailableOption.find('label').data('table-column');
        } else {
            optionAvailableText = selectAvailableOption.find('label').text();
        }

        var fieldInput = activeField.find('li.token-search input');
        fieldInput.val(optionAvailableText);

        fieldInput.trigger('click');
        fieldInput.trigger('keyup');
        $('.tokenize-dropdown').filter('.dropdown').find('.dropdown-item').trigger('mousedown');

        fieldInput.val('');
        fieldInput.trigger('click');
        fieldInput.trigger('keyup');

        activeField.find('.tokenize').trigger('focusin');
        activeField.find('.tokenize').trigger('focusout');
    });

    $(document.body).on('click', '.api_field_head', function () {
        // set active
        var $box = $(this).closest('.api_field_box');

        if ($box.hasClass('status_active')) {
            // already active - inactivate it
            $box.removeClass('status_active');
        } else {
            // inactive

            // first deactivate all the other boxes

            $('.api_fields_container').find('.status_active').removeClass('status_active');

            // activate current box

            $box.addClass('status_active');
            $box.children('.api_field_body').slideDown();
            $box.find('.tokenize').trigger('focusin');
            $box.find('.tokenize').trigger('focusout');
        }

    });

    $(document.body).on('focusin', '.tokenize', function() {
        var tokens = $(this).find('.tokens-container li.token span');

        $('.tokenize.active').removeClass('active');
        $(this).addClass('active');

        $.each(tokens, function(i, tokenHTML) {
            var token = $(tokenHTML);

            if(token.hasAttr('data-option')) {
                token.text(token.attr('data-option'));
            }
        });
    });

    $(document.body).on('click', '#create-tag', function () {
        var tag_text = $(this).parent().find('input[type="text"]').val();

        if (tag_text) {
            var data = {
                action: 'add_new_klick_tip_tag',
                new_tag: tag_text
            };

            $.post(ajaxurl, data, function (response) {
                displayNotice(response);

                if (1 === response.status) {
                    var tags = [];
                    tags.push({
                        tag_id: response.tag_id,
                        tag_name: tag_text
                    });

                    updateTagsLists('add', tags);
                }
            }, 'json');
        }
    });

    $(document.body).on('click', '#remove-tag', function () {
        var selected_tags = $('.remove-tags-cloud input:checked');

        if (selected_tags.length < 1) {
            alert('Please, select one or more tags from the list.')
        } else {
            var sure = confirm('Be aware! You delete Tags in Klick-Tipp! Yes, i want to delete selected ' + selected_tags.length + ' Tags in Klick-Tipp.');

            if (sure) {
                var tags_ids = [];

                $.each(selected_tags, function (index, tag) {
                    tags_ids.push($(tag).val());
                });

                var data = {
                    action: 'remove_klick_tip_tag',
                    tags_ids: tags_ids
                };

                $.post(ajaxurl, data, function (response) {
                    displayNotice(response);

                    if (1 === response.status) {
                        updateTagsLists('remove', response.deleted_tags);
                    }
                }, 'json');
            }
        }
    });

    $(document.body).on('change keyup paste mouseup', '.create-tag-wrapper .tag-text', function () {
        var value = $.trim($(this).val());
        var tags = $('.tags-cloud input[type="checkbox"]');
        var create_btn = $('#create-tag');

        $.each(tags, function (index, tag) {
            var tag_value = $(tag).val();

            if (value === tag_value) {
                create_btn.prop('disabled', true);
                return false;
            } else {
                create_btn.prop('disabled', false);
            }
        });

        filterAvailableTags(tags, value);
    });

    $(document.body).on('change keyup paste mouseup', '.remove-tags-wrapper .tag-text', function () {
        var value = $.trim($(this).val());
        var tags = $('.remove-tags-cloud input[type="checkbox"]');
        var remove_btn = $('#remove-tag');

        $.each(tags, function (index, tag) {
            var tag_value = $(tag).val();

            if (value === tag_value) {
                remove_btn.prop('disabled', true);
                return false;
            } else {
                remove_btn.prop('disabled', false);
            }
        });

        filterAvailableTags(tags, value);
    });

    $(document.body).on('change keyup paste mouseup', '.detach-tags-wrapper .tag-text', function () {
        var value = $.trim($(this).val());
        var tags = $('.detach-tags-wrapper-selection input[type="checkbox"]');
        var detach_btn = $('#detach-tag');

        $.each(tags, function (index, tag) {
            var tag_value = $(tag).val();

            if (value === tag_value) {
                detach_btn.prop('disabled', true);
                return false;
            } else {
                detach_btn.prop('disabled', false);
            }
        });

        filterAvailableTags(tags, value);
    });

    $(document.body).on('click', '#select-all-for-remove', function () {
        var tags_wrapper = $('.remove-tags-cloud');
        var visible_tags = tags_wrapper.find('fieldset:visible input[type="checkbox"]');

        $.each(visible_tags, function (index, tag) {
            $(tag).attr('checked', 'checked');
        });
    });

    $(document.body).on('click', '#select-all-for-detach',function () {
        var tags_wrapper = $('.detach-tags-wrapper-selection');
        var visible_tags = tags_wrapper.find('fieldset:visible input[type="checkbox"]');

        $.each(visible_tags, function (index, tag) {
            $(tag).attr('checked', 'checked');
        });

        setTimeout(function() {
            updatePossibleTagsOnChange();
        }, 800);
    });

    $(document.body).on('click', '#deselect-all-for-detach', function () {
        var tags_wrapper = $('.detach-tags-wrapper-selection');
        var visible_tags = tags_wrapper.find('fieldset:visible input[type="checkbox"]');

        $.each(visible_tags, function (index, tag) {
            $(tag).attr('checked', false);
        });

        setTimeout(function() {
            updatePossibleTagsOnChange();
        }, 800);
    });

    $(document.body).on('click', '.detach-tags-wrapper-selection fieldset input', function() {
        updatePossibleTagsOnChange();
    });

    $(document.body).on('click', '.tags-cloud fieldset input', function() {
        updatePossibleTagsOnChange();
        // updatePossibleTagsOnChange();
    });

    $(document.body).on('click', '.tags-cloud > fieldset', function () {
        var input = $(this).find('input');
        var tags_wrapper = $('.selected-tags-wrapper');
        var savedMapInput = $('input.mapping');

        var data = {
            id: input.attr('id'),
            text: input.val()
        };

        var alreadySelected = tags_wrapper.find('.selected-tag[data-tag-id="' + data.id + '"]');

        if ('checked' === input.attr('checked')) {
            if (alreadySelected.length < 1) {
                tags_wrapper.append(createTag(data));
            }
        } else {
            tags_wrapper.find('div[data-tag-id="' + input.attr('id') + '"]').remove();
        }

        if (!window.manuallySelectedTagsOnLoad) {
            var api_object = compileMapToAPIObject();
            var api = JSON.stringify(api_object);

            savedMapInput.data('new_value', api);
        }
    });

    $(document.body).on('click', '#show_empty_fields', function() {
        var data = {
            action: 'wp2l_delete_transient',
            transient_name: 'wp2lead_map_to_api_hide_empty_fields'
        };

        $.post(ajaxurl, data, function(response) {
            var availableOptionsList = $(document.body).find('.available_options .available_option_list');
            availableOptionsList.toggleClass('hide-empty-options');
            $(document.body).find('#hide_empty_fields').show();
            $(document.body).find('#show_empty_fields').hide();
        });
    });

    $(document.body).on('click', '#hide_empty_fields', function() {
        var data = {
            action: 'wp2l_set_transient',
            transient_name: 'wp2lead_map_to_api_hide_empty_fields',
            transient_value: 1
        };

        $.post(ajaxurl, data, function(response) {
            var availableOptionsList = $(document.body).find('.available_options .available_option_list');
            availableOptionsList.toggleClass('hide-empty-options');
            $(document.body).find('#hide_empty_fields').hide();
            $(document.body).find('#show_empty_fields').show();
        });
    });

    $(document.body).on('change', '.api_field_option', function () {
        var $box = $(this).closest('.api_field_box');

        $box.find('.field_value').html($(this).val());
    });

    $(document).on('mousedown', '.tokenize-dropdown .dropdown-item', function() {
        var activeField = $(document.body).find('.api_fields_container .api_field_box').filter('.status_active');
        activeField.find('.tokenize').trigger('focusin');
    });

    $(document.body).on('change keyup', '#inputFiledSearchKT input', function() {
        var searchText = $(this).val();
        var fieldsKT = $(document.body).find('.api_fields_container .api_field_box');

        $.each(fieldsKT, function(index, fieldKTHTML) {
            var fieldKT = $(fieldKTHTML);
            var fieldName = fieldKT.find('.api_field_head .field_label').text();

            if(fieldName.search(new RegExp(searchText, 'i')) !== -1) {
                fieldKT.show();
            } else {
                fieldKT.hide();
            }
        });
    });

    $(document.body).on('change keyup', '#inputFiledSearchOption input', function() {
        var searchText = $(this).val();
        var fieldsOptions = $(document.body).find('.available_options .available_option');

        $.each(fieldsOptions, function(index, fieldOptionHTML) {
            var fieldOption = $(fieldOptionHTML);
            var fieldName = fieldOption.find('label').text();

            if(fieldName.search(new RegExp(searchText, 'i')) !== -1) {
                fieldOption.show();
            } else {
                fieldOption.hide();
            }
        });
    });

    $(document.body).on('click','#btnUpdateMapToApi',function(e) {
        window.spinner.show();
        e.preventDefault();
        var global_tag_prefix = $('#globalTagPrefix').val();

        var data = {
            action: 'wp2l_save_new_map',
            map_id: $_GET('active_mapping'),
            global_tag_prefix: global_tag_prefix,
            api: JSON.stringify(compileMapToAPIObject())
        };

        // shoot off the ajax request
        $.post(ajaxurl, data, function (response) {
            var decoded = $.parseJSON(response);

            if (decoded.success) {
                if (decoded.mapping) {
                    $('.mapping').val(decoded.mapping);
                }

                alert('Map successfully saved!');
                window.location.href = '?page=wp2l-admin&tab=map_to_api';
            } else {
                alert('Something went wrong.');
            }

            window.spinner.hide();
        });
    });

    $(document.body).on('click', '.add_new_condition', function (e) {
        e.preventDefault();
        var list = $(this).parent().find('.conditions-list');
        var type = $(this).data('type');
        var template = Handlebars.compile($('#wp2l-api-' + type + '-condition-set')[0].innerHTML);
        var available_options = $('.available_options .available_option > label');
        var connect_to = null;

        if ('tags' === type) {
            connect_to = $('.' + type + '-cloud input[type="checkbox"]');
        } else {
            connect_to = $('.' + type + '-list option');
        }

        var options = [];
        var connectTo = [];

        $.each(available_options,function (index, label) {
            options[options.length] = $(label).data('table-column');
        });

        $.each(connect_to,function (index, item) {
            var option = $(item);

            if ('tags' === type) {
                connectTo[connectTo.length] = {
                    code: option.attr('id'),
                    value: option.val()
                };
            } else {
                connectTo[connectTo.length] = {
                    code: option.val(),
                    value: option.text()
                };
            }
        });

        list.append(template({
            availableOptions: options,
            connectTo: connectTo
        }));

        list.find('.options_where').last().tokenize2({
            tokensMaxItems: 1,
            searchFromStart: false
        });
    });

    $(document.body).on('click', '.remove-api-separator', function () {
        $(this).parent().remove();

        setTimeout(function() {
            updatePossibleTagsOnChange();
        }, 800);
    });

    $(document.body).on('click', '.add_new_separator', function () {
        var list = $(this).parent().find('.separators-list');
        var template = Handlebars.compile($('#wp2l-api-tags-separator-set')[0].innerHTML);
        var available_options = $('.available_options .available_option > label');
        var options = [];

        $.each(available_options,function (index, label) {
            options[options.length] = $(label).data('table-column');
        });

        list.append(template({
            availableOptions: options
        }));

        list.find('.options_where').last().tokenize2(
            {
                searchFromStart: false
            }
        );
    });

    $(document.body).on('click', '.add_new_detach_condition', function () {
        var list = $(this).parent().find('.conditions-list');
        var type = $(this).data('type');
        var template = Handlebars.compile($('#wp2l-api-tags-condition-detach')[0].innerHTML);
        var available_options = $('.available_options .available_option > label');
        var connect_to = $('.tags-cloud input[type="checkbox"]');
        var options = [];
        var connectTo = [];

        $.each(available_options,function (index, label) {
            options[options.length] = $(label).data('table-column');
        });

        $.each(connect_to,function (index, item) {
            var option = $(item);

            connectTo[connectTo.length] = {
                code: option.attr('id'),
                value: option.val()
            };
        });

        list.append(template({
            availableOptions: options,
            connectTo: connectTo
        }));

        list.find('.options_where').last().tokenize2({
            tokensMaxItems: 1,
            searchFromStart: false
        });
    });

    $(document.body).on('change', '.tags-detach-conditions-wrapper select[name="tags-detach"], .tags-detach-conditions-wrapper select[name="operator"], .tags-detach-conditions-wrapper select[name="option"]', function () {
        setTimeout(function() {
            updatePossibleTagsOnChange();
        }, 800);
    });

    $(document.body).on('change', '.tags-conditions-wrapper select[name="tags"], .tags-conditions-wrapper select[name="operator"], .tags-conditions-wrapper select[name="option"]', function () {
        setTimeout(function() {
            updatePossibleTagsOnChange();
        }, 800);
    });

    $(document.body).on('input', '.tags-detach-conditions-wrapper input[name="string"], .tags-conditions-wrapper input[name="string"], .separator-wrapper input[name="separator"]', function() {
        setTimeout(function() {
            updatePossibleTagsOnChange();
        }, 800);
    });

    $(document.body).on('blur', '#globalTagPrefix, #mapTagPrefix', function() {
        updatePrefixesSection();

        setTimeout(function() {
            updatePossibleTagsOnChange();
        }, 800);
    });

    function updatePrefixesSection() {
        var tagsPrefix = '';
        var mapGlobalTagsPrefixInput = $('#globalTagPrefix');
        var mapTagsPrefixInput = $('#mapTagPrefix');

        var mapGlobalTagsPrefix = $.trim(mapGlobalTagsPrefixInput.val());
        var mapTagsPrefix = $.trim(mapTagsPrefixInput.val());

        var mapGlobalTagsPrefixOld = $.trim(mapGlobalTagsPrefixInput.data('selected-value'));
        var mapTagsPrefixOld = $.trim(mapTagsPrefixInput.data('selected-value'));

        var warningNoPrefix = $('.tagPrefixWarning__noprefix');
        var warningGlobalChanged = $('.tagPrefixWarning__globalchange');
        var mapTagPrefixHolder = $('#mapTagPrefix__holder');

        var warningNoPrefixTemplate = Handlebars.compile($('#wp2l-tag-prefix-warning-noprefix')[0].innerHTML);
        var warningGlobalChangedTemplate = Handlebars.compile($('#wp2l-tag-prefix-warning-globalchange')[0].innerHTML);

        if (mapGlobalTagsPrefix) {
            tagsPrefix = mapGlobalTagsPrefix + ' ';
        }

        if (mapTagsPrefix) {
            tagsPrefix = mapTagsPrefix + ' ';
        }

        // Check if Tags is empty
        if ('' === tagsPrefix) {
            if (warningNoPrefix.length === 0) {
                mapTagPrefixHolder.after(warningNoPrefixTemplate({}));
            }
        } else {
            if (warningNoPrefix.length > 0) {
                warningNoPrefix.remove();
            }
        }

        // Check if Global Changed
        if (
            ('' !== mapGlobalTagsPrefixOld && mapGlobalTagsPrefix !== mapGlobalTagsPrefixOld) ||
            ('' !== mapTagsPrefixOld && mapTagsPrefix !== mapTagsPrefixOld)
        ) {
            if (warningGlobalChanged.length === 0) {
                mapTagPrefixHolder.after(warningGlobalChangedTemplate({}));
            }
        } else {
            if (warningGlobalChanged.length > 0) {
                warningGlobalChanged.remove();
            }
        }
    }

    function saveNewPrefixesValues() {
        var tagsPrefix = '';
        var mapGlobalTagsPrefixInput = $('#globalTagPrefix');
        var mapTagsPrefixInput = $('#mapTagPrefix');

        var mapGlobalTagsPrefix = $.trim(mapGlobalTagsPrefixInput.val());
        var mapTagsPrefix = $.trim(mapTagsPrefixInput.val());

        var mapGlobalTagsPrefixOld = $.trim(mapGlobalTagsPrefixInput.data('selected-value'));
        var mapTagsPrefixOld = $.trim(mapTagsPrefixInput.data('selected-value'));

        var warningNoPrefix = $('.tagPrefixWarning__noprefix');
        var warningGlobalChanged = $('.tagPrefixWarning__globalchange');
        var mapTagPrefixHolder = $('#mapTagPrefix__holder');

        mapGlobalTagsPrefixInput.data('selected-value', mapGlobalTagsPrefix);
        mapTagsPrefixInput.data('selected-value', mapTagsPrefix);

        if (warningGlobalChanged.length > 0) {
            warningGlobalChanged.remove();
        }
    }

    $(document.body).on('mousedown', '.tags-detach-conditions-wrapper .tokenize-dropdown .dropdown-item', function() {
        setTimeout(function() {
            updatePossibleTagsOnChange();
        }, 800);
    });

    $(document.body).on('click', '.remove-api-connection', function() {
        $(this).parents('.condition').remove();

        setTimeout(function() {
            updatePossibleTagsOnChange();
        }, 800);
    });

    $(document.body).on('click', '#transferAllBg', function () {
        var modal = $('.transfer-data-modal'),
            noticeHolder = modal.find('.notice_holder');

        noticeHolder.empty();

        var resultInProgress = Handlebars.compile($('#wp2l-map-to-api-bg-in-progress')[0].innerHTML);
        noticeHolder.append(resultInProgress({}));

        $('.transfer-data-modal .api-processing-holder .api-spinner-holder').addClass('api-processing');

        setTimeout(function() {
            transferDataToKlickTipPromise()
                .then(function(response) {
                    alert(window.transferedDataCount + ' users started transfered in background');

                    noticeHolder.empty();

                    var bgStatisticHolder = $('#map-to-api-bg-running-inner');

                    if (bgStatisticHolder.length > 0) {
                        refreshAllBgMapToApi();
                    } else {
                        var data = {
                            action: 'wp2l_get_map_to_api_statistics'
                        };

                        $.post(
                            ajaxurl,
                            data,
                            function (response) {
                                var decoded = $.parseJSON(response);

                                if (decoded.success) {
                                    $( "#wpbody-content .wrap > h1" ).after(decoded.html);
                                } else {
                                    alert(decoded.message);
                                }
                            }
                        );

                    }


                    $('.transfer-data-modal .api-processing-holder .api-spinner-holder').removeClass('api-processing');
                })
        }, 1000)
    });

    function refreshAllBgMapToApi() {
        var data = {
            action: 'wp2l_refresh_all_map_to_api'
        };

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    var noticeHolder = $('#map-to-api-bg-running-inner');
                    noticeHolder.html(decoded.html);

                } else {
                    alert(decoded.message);
                }
            }
        );
    }

    $(document.body).on('click', '#transferAllBg1', function () {
        blockTransferModal();

        var map_id = $(this).data('active-map');

        var data = {
            action: 'wp2l_transfer_to_klicktipp_bg',
            map_id: map_id
        };

        $.post(ajaxurl, data, function(response) {
            var decoded = $.parseJSON(response);

            if (decoded.success) {
                alert(decoded.message);

                unblockTransferModal();
            } else {
                alert('Something went wrong.');

                unblockTransferModal();
            }
        });
    });

    $(document.body).on('click', '.gray-back, .transfer-data-modal .close', function() {
        $('.transfer-data-modal').remove();
        $('.gray-back').remove();
    });

    $(document.body).on('click', '#btnTransferData', function () {
        var apiTransferModalTemplate = Handlebars.compile($('#wp2l-api-transfer-modal')[0].innerHTML),

            activeMap = $(this).data('active-map'),
            cronChecked = $(this).data('cron-checked'),
            cronSelected = $(this).data('cron-selected');

        $('body').append(apiTransferModalTemplate({
            active_map: activeMap
        }));

        $(".transfer-data-modal").center();

        var date_base_for_cron_selection = $('.date-base-for-cron'),
            date_base_for_cron_selected = date_base_for_cron_selection.data('selected');

        $.each(cronSelected, function( index, value ) {
            date_base_for_cron_selection.find('option[value="' + value + '"]').prop('selected', true);
        });

        var modal = $('.transfer-data-modal'),
            noticeHolder = modal.find('.notice_holder');

        noticeHolder.empty();

        var resultInProgress = Handlebars.compile($('#wp2l-map-to-api-prepare-message-in-progress')[0].innerHTML);
        noticeHolder.append(resultInProgress({}));

        setTimeout(function() {
            prepareDataForKlickTipPromise()
                .then(function(results) {
                    return getTransferModalDataInfoPromise();
                })
                .then(function(transferModalInfo) {
                    var decodedTransferModalInfo = $.parseJSON(transferModalInfo),
                        transfer_current_btn = $('#transferCurrent'),
                        transfer_all_bg_btn = $('#transferAllBg');

                    if (decodedTransferModalInfo.success) {
                        modal.find('.available-data .total').text(window.preparedForTransferCount);

                        // Statistics
                        modal.find('.last-transferred .total').text(decodedTransferModalInfo.last_transfered);
                        modal.find('.all-transferred .total').text(decodedTransferModalInfo.totally_all);
                        modal.find('.unique-transferred .total').text(decodedTransferModalInfo.totally_unique);
                        modal.find('.cron-local .total').text(decodedTransferModalInfo.last_transfered_cron);
                        modal.find('.cron-unix .total').text(decodedTransferModalInfo.last_transfered_cron_unix);

                        $('.date-base-for-cron').fastselect();

                        setTimeout(function () {
                            noticeHolder.empty();

                            if (0 === window.preparedForTransferCount) {
                                var noDataForTransferTemplate = Handlebars.compile($('#wp2l-no-users-for-transfer')[0].innerHTML);
                                noticeHolder.append(noDataForTransferTemplate({}));
                            } else {
                                transfer_current_btn.addClass('button-primary').prop('disabled', false);
                                transfer_all_bg_btn.addClass('button-primary').prop('disabled', false);
                            }

                            $('.transfer-data-modal .api-processing-holder .api-spinner-holder').removeClass('api-processing');
                        }, 1000);
                    }
                });

        }, 1000);
    });

    $(document.body).on('click', '#transferCurrent', function () {
        $('.transfer-data-modal .api-processing-holder .api-spinner-holder').addClass('api-processing');

        setTimeout(function() {
            transferCurrentToKlickTipp();
        }, 1000);
    });

    $(document.body).on('click', '#btnTransferData1', function () {
        var active_map = $(this).data('active-map'),
            cronChecked = $(this).data('cron-checked'),
            cronSelected = $(this).data('cron-selected'),
            current_user_email = $('.api-fields-wrapper #api_email .token > span').data('value'),
            template = Handlebars.compile($('#wp2l-api-transfer-modal')[0].innerHTML),
            available_options = $('.available_options .available_option > label');

        var options = [];

        $.each(available_options,function (index, label) {
            options[options.length] = $(label).data('table-column');
        });

        $('body').append(template({
            active_map: active_map
        }));

        blockTransferModal();

        prepareDataForTransfer(active_map);

        var transfer_current_btn = $('#transferCurrent');

        if (!current_user_email) {
            transfer_current_btn.prop('disabled', true);
        }

        $(".transfer-data-modal").center();

        $('.close').on('click', function () {
            $('.transfer-data-modal').remove();
            $('.gray-back').remove();
        });

        $('.gray-back').on('click', function () {
            $('.transfer-data-modal').remove();
            $(this).remove();
        });

        transfer_current_btn.on('click', function () {
            blockTransferModal();
            var map_id = $(this).data('active-map');

            transferInformationToKlickTipp(map_id, current_user_email);
        });

        var date_base_for_cron_selection = $('.date-base-for-cron'),
            date_base_for_cron_selected = date_base_for_cron_selection.data('selected');

        $.each(cronSelected, function( index, value ) {
            date_base_for_cron_selection.find('option[value="' + value + '"]').prop('selected', true);
        });

        $('.date-base-for-cron').fastselect();

        // date_base_for_cron_selection.find('option[value="' + date_base_for_cron_selection.data('selected') + '"]').prop('selected', true);
    });

    $(document.body).on('click', '#saveCronSeettings', function () {
        var map_id = $(this).data('active-map'),
            cron_status = $('#cron-status').attr('checked'),
            date_base = $('.date-base-for-cron').val(),
            data = {
                action: 'wp2l_save_cron_settings',
                map_id: map_id,
                cron_status: cron_status,
                date_base_for_cron: date_base
            };

        if ( 'checked' === cron_status && null === date_base ) {
            alert('Please, choose one or more trigger from the list.');

            return;
        }

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response),
                    btnTransferData = $('#btnTransferData'),
                    titleCronStatus = $('h3.title .dashicons-clock'),
                    listCronStatus = $('.available-maps__table #map-' + map_id + '-row .dashicons-clock');

                if (decoded.success) {
                    btnTransferData.data('cron-checked', decoded.cronChecked);
                    btnTransferData.data('cron-selected', $.parseJSON(decoded.cronSelected));
                    titleCronStatus.removeClass('disabled').removeClass('active');
                    listCronStatus.removeClass('disabled').removeClass('active')

                    if ( '' === decoded.cronChecked ) {
                        titleCronStatus.addClass('disabled');
                        listCronStatus.addClass('disabled');
                    } else {
                        titleCronStatus.addClass('active');
                        listCronStatus.addClass('active');
                    }

                    alert(decoded.message);
                } else {
                    alert('Something went wrong.');
                }
            }
        );
    });

    $(document.body).on('change', '.api-optins-wrapper .optins-list', function () {
        updateOptinFromCondition();
    });

    window.apiFieldsOnLoad = true;
    window.manuallySelectedTagsOnLoad = true;
    var iterationLimit = 500;

    $(document).ready(function () {

        window.possibleTagsOnLoad = true;

        var page = $_GET('tab');

        if ('map_to_api' !== page) {
            return false;
        }

        var currentMapId = $_GET('active_mapping');

        if (!currentMapId) {
            return false;
        }

        window.spinner = $('.api-spinner');
        window.mapResultsLimit = 1000;
        window.mapResults = [];
        window.firstMapResultLoaded = false;

        $.post(ajaxurl, {
            action: 'wp2l_get_map_query_results_limit'
        }, function (response) {
            var decoded = $.parseJSON(response);
            window.mapResultsLimit = decoded.limit;
        });

        $('.api-field').tokenize2({
            searchFromStart: false
        });

        var data = [];
        var types = ['optins', 'tags', 'tags-detach'];

        getMapRowsCountPromise()
            .then(function(response) {
                var decoded = $.parseJSON(response);

                return getMapResultsPromise(decoded.message);

        })
            .then(function(mapResults) {
                var mapId = $_GET('active_mapping');

                var count = window.mapResults.length;

                var data = {
                    action: 'wp2l_get_available_options_data',
                    mapId: mapId,
                    count: count,
                    mapResult: window.mapResults[0]
                };

                return $.post(ajaxurl, data, function (response) {});

        })
            .then(function(response) {
            var decoded = $.parseJSON(response);

            if (decoded.success) {
                window.firstMapResultLoaded = true;

                var options_wrapper = $('.available_options');
                options_wrapper.html(decoded.availableOptions);
                return true;
            }
        })
            .then(function() {

                var new_options = $('.available_options .available_option > label');
                var field_options = [];

                $.each(new_options, function (index, label) {
                    field_options[field_options.length] = $(label).text();
                });

                updateApiFields(field_options, true);

                updateOptinFromCondition();

                loadConditions(types);

                loadSeparators();

                loadConnectedOptions();

                getUsersTagsFromKlickTipp(null);

                selectTagsFromConnectedOptions();

                selectTags();

                updateManuallySelectedTags();

                loadPossibleTagsCloud(null);

                if (window.innerWidth >= 961) {
                    $(".wp2leads-sticky").sticky({topSpacing:35});
                }

                $('#map-to-api-message-in-progress').remove();
                $('.accordion-body.api-processing-holder .api-spinner-holder').removeClass('api-processing');
        });

        $.post(ajaxurl, {action: 'wp2l_transfer_to_klicktipp_last'}, function (response) {
            var decoded = $.parseJSON(response);

            if (decoded.count !== undefined && decoded.now !== undefined && decoded.map_id !== undefined) {
                if(Number.parseInt(decoded.now) > 0 && decoded.map_id == $_GET('active_mapping')) {
                    $(document.body).find('#btnUpdateMapToApi').trigger('click');
                }
            }
        });

        // window.spinner.hide();
    });


    $(window).on('beforeunload', function (e) {
        e = e || window.event;

        if (!preventLoosingData('browser-navigation')) {
            // For IE and Firefox
            if (e) {
                e.returnValue = 'You have unsaved changes!';
            }

            return 'You have unsaved changes!';
        }
    });

    if (window.addEventListener) {
        window.addEventListener('resize', resizer, false);
    } else if (window.attachEvent) {
        window.attachEvent('onresize', resizer);
    }

    function resizer() {
        var stickyContent = $('.map2api_body .sticky-wrapper');

        if (window.innerWidth >= 961) {
            if (stickyContent.length === 0) {
                $(".wp2leads-sticky").sticky({topSpacing:35});
            }
        } else {
            if (stickyContent.length > 0) {
                $(".wp2leads-sticky").unstick();
            }
        }
    }

    function updatePossibleTagsOnChange() {
        var currentMap = compileMapToAPIObject();

        var tagsCloud = $('.tags-cloud', document.body);

        var existedTags = $('#tags-cloud-options').data('tags-cloud');
        var currentUserKTTag = window.currentUserKTTag;
        var manuallySelectedTags = currentMap.manually_selected_tags.tag_ids;
        var manuallyDetachTags = currentMap.detach_tags.tag_ids;
        var connectedTags = currentMap.connected_for_tags.tags;
        var connectedTagsSeparator = currentMap.connected_for_tags.separators;
        var connectedTagsConcat = currentMap.connected_for_tags.tags_concat;
        var connectedTagsSeparators = currentMap.connected_for_tags.separators;
        var conditionsTags = currentMap.conditions.tags;
        var conditionsDetachTags = currentMap.conditions.detach_tags;

        var tagsPrefix = '';
        var mapGlobalTagsPrefix = $.trim($('#globalTagPrefix').val());
        var mapTagsPrefix = $.trim($('#mapTagPrefix').val());

        if (mapGlobalTagsPrefix) {
            tagsPrefix = mapGlobalTagsPrefix + ' ';
        }

        if (mapTagsPrefix) {
            tagsPrefix = mapTagsPrefix + ' ';
        }

        var newTagsArray = [];

        var selectedTagsCloudWrapper = $('.selected-tags-cloud-wrapper');

        selectedTagsCloudWrapper.empty();

        if (conditionsTags) {
            $.each(conditionsTags, function(conditionIndex, condition) {

                var option = $('.available_option label[data-table-column="' + condition.option + '"]');

                if (option.length > 0) {
                    $.each(option, function (index, opt) {

                        var tag_text = $(opt).data('value');

                        if (prepareCondition(tag_text, condition)) {
                            manuallySelectedTags.push(condition.connectTo);
                        }
                    });
                }
            });
        }

        if (conditionsDetachTags) {
            $.each(conditionsDetachTags, function(conditionIndex, condition) {

                var option = $('.available_option label[data-table-column="' + condition.option + '"]');

                if (option.length > 0) {
                    $.each(option, function (index, opt) {

                        var tag_text = $(opt).data('value');

                        if (prepareCondition(tag_text, condition)) {
                            manuallyDetachTags.push(condition.connectTo);
                        }
                    });
                }
            });
        }

        if (connectedTagsSeparator) {
            $.each(connectedTagsSeparator, function(index, separator) {

                if (separator.separator && separator.option.length > 0) {

                    $.each(separator.option, function(index, table_column) {
                        var option = $('.available_option label[data-table-column="' + table_column + '"]');

                        if (option.length > 0) {
                            $.each(option, function (index, opt) {
                                var tag_text = $(opt).data('value');
                                var tags_names = tag_text.split(separator.separator);

                                $.each(tags_names, function (tagIndex, item) {

                                    var tag_text = tagsPrefix + $.trim(item);

                                    var tag_type = typeof tag_text;

                                    if ('number' === tag_type) {
                                        var tagToCheck = tag_text.toString();
                                    } else {
                                        var tagToCheck = tag_text;
                                    }

                                    var existedTagData = getExistedTagByName(tagToCheck);

                                    if (existedTagData) {
                                        manuallySelectedTags.push(existedTagData.id);
                                    } else {
                                        var newTagData = {
                                            id: '',
                                            text: tagToCheck,
                                            tagClass: 'selected-tag selected-tag-new'
                                        };

                                        newTagsArray.push(newTagData);
                                    }
                                });

                            });
                        }
                    });
                }
            });
        }

        if (connectedTags) {

            $.each(connectedTags, function(tagIndex, connected_column) {
                var option = $('.available_option label[data-table-column="' + connected_column + '"]');

                if (option.length > 0) {
                    $.each(option, function (index, opt) {

                        var tag_text = tagsPrefix + $.trim($(opt).data('value'));
                        var tag_type = typeof tag_text;

                        if ('number' === tag_type) {
                            var tagToCheck = tag_text.toString();
                        } else {
                            var tagToCheck = tag_text;
                        }

                        var existedTagData = getExistedTagByName(tagToCheck);

                        if (existedTagData) {
                            manuallySelectedTags.push(existedTagData.id);
                            //connectedTags.splice(tagIndex, 1);
                        } else {
                            var newTagData = {
                                id: '',
                                text: tagToCheck,
                                tagClass: 'selected-tag selected-tag-new'
                            };

                            newTagsArray.push(newTagData);
                        }
                    });
                }
            });
        }

        if (connectedTagsConcat) {
            $.each(connectedTagsConcat, function(index, table_column) {
                var option = $('.available_option label[data-table-column="' + table_column + '"]');

                if (option.length > 0) {
                    $.each(option, function (index, opt) {
                        var tag_text = $(opt).data('value');
                        var tags_names = tag_text.split(',');

                        $.each(tags_names, function (tagIndex, item) {
                            var tag_name = tagsPrefix + $.trim(item);

                            var tag_type = typeof tag_name;

                            if ('number' === tag_type) {
                                var tagToCheck = tag_name.toString();
                            } else {
                                var tagToCheck = tag_name;
                            }

                            var existedTagData = getExistedTagByName(tagToCheck);

                            if (existedTagData) {
                                manuallySelectedTags.push(existedTagData.id);
                            } else {
                                var newTagData = {
                                    id: '',
                                    text: tagToCheck,
                                    tagClass: 'selected-tag selected-tag-new'
                                };

                                newTagsArray.push(newTagData);
                            }
                        });

                    });
                }
            });
        }

        manuallySelectedTags = $.unique( manuallySelectedTags );
        manuallyDetachTags = $.unique( manuallyDetachTags );

        if (currentUserKTTag) {

            $.each(currentUserKTTag, function (index, tag_id) {

                var isManualSelected = $.inArray( tag_id, manuallySelectedTags );
                var isDetachSelected = $.inArray( tag_id, manuallyDetachTags );

                var tagClass = 'selected-tag selected-tag-kt';

                if (-1 !== isManualSelected) {
                    manuallySelectedTags.splice(isManualSelected, 1);

                    tagClass += ' selected-tag-manual';
                }

                if (-1 !== isDetachSelected) {
                    tagClass += ' selected-tag-detach';
                }

                if (tag_id) {
                    var checkbox = tagsCloud.find('input[id="' + tag_id + '"]');

                    var data = {
                        id: tag_id,
                        text: checkbox.data('name'),
                        tagClass: tagClass
                    };

                    selectedTagsCloudWrapper.append(createPossibleTag(data));
                }
            })
        }

        if (manuallySelectedTags) {
            $.each(manuallySelectedTags, function (index, tag_id) {
                if (tag_id) {

                    var isDetachSelected = $.inArray( tag_id, manuallyDetachTags );

                    if (-1 === isDetachSelected) {
                        var checkbox = tagsCloud.find('input[id="' + tag_id + '"]');

                        var data = {
                            id: tag_id,
                            text: checkbox.data('name'),
                            tagClass: 'selected-tag selected-tag-new'
                        };

                        selectedTagsCloudWrapper.append(createPossibleTag(data));
                    }

                }
            })
        }

        if (newTagsArray.length > 0) {
            $.each(newTagsArray, function (index, tagData) {
                selectedTagsCloudWrapper.append(createPossibleTag(tagData));
            });
        }
    }

    function loadPossibleTagsCloud(email, cb) {

        var mapId = $_GET('active_mapping');
        var currentMap = JSON.stringify(compileMapToAPIObject());

        if (null === email || undefined === email) {
            email = $('.api-fields-wrapper #api_email .token > span').data('value');
        }

        var offset = $('.options-buttons-wrapper .prev.button').data('page');
        var currentUserData = JSON.stringify(window.mapResults[offset]);
        var tagsCloud = JSON.stringify($('#tags-cloud-options').data('tags-cloud'));
        var tagsPrefix = '';
        var mapGlobalTagsPrefix = $.trim($('#globalTagPrefix').val());
        var mapTagsPrefix = $.trim($('#mapTagPrefix').val());

        if (mapGlobalTagsPrefix) {
            tagsPrefix = mapGlobalTagsPrefix;
        }

        if (mapTagsPrefix) {
            tagsPrefix = mapTagsPrefix;
        }

        $.ajax({
            type: 'post',
            url: ajaxurl,
            async: false,
            data: {
                action: 'wp2l_load_possible_tags_cloud',
                mapId: mapId,
                map: currentMap,
                email: email,
                tagsCloud: tagsCloud,
                tagsPrefix: tagsPrefix,
                userData: currentUserData
            },
            success: function(response) {
                var decoded = $.parseJSON(response);

                var selectedTagsCloudWrapper = $('.selected-tags-cloud-wrapper');

                if (decoded.success) {
                    selectedTagsCloudWrapper.html(decoded.possible_tags_cloud);

                    if (typeof cb === 'function') {
                        cb();
                    }
                } else {
                    selectedTagsCloudWrapper.html(decoded.message);

                    if (typeof cb === 'function') {
                        cb();
                    }
                }

                window.possibleTagsOnLoad = false;
            },
            error: function(xhr, status, error) {

            },
            complete: function(xhr, status) {

            }
        })
    }

    function getMapRowsCountPromise() {
        var mapId = $_GET('active_mapping');
        var resultInProgress = Handlebars.compile($('#wp2l-map-to-api-message-in-progress')[0].innerHTML);
        $('#map-to-api-message-in-progress__holder').append(resultInProgress({}));

        return $.ajax({
            url: ajaxurl,
            method: 'post',
            data: {
                mapId: mapId,
                action: 'wp2l_get_map_rows_count'
            },
            success: function (response) {},
            error: function (xhr, status, error) {
                console.log(xhr);
                console.log(status);
                console.log(error);
            },
            complete: function (xhr, status) {
            }
        });
    }

    function getMapResultsPromise(count) {
        // var limit = 2000;
        var limit = iterationLimit;
        var offset = 0;
        var iterations = Math.ceil(count / limit);
        var mapId = $_GET('active_mapping');
        var promises = [];
        var results = [];

        window.mapResultsIterations = iterations;

        for (var i = 0; i < iterations; i++) {
            offset = limit * i;

            promises.push(
                $.ajax({
                    type: 'post',
                    url: ajaxurl,
                    async: false,
                    data: {
                        action: 'wp2l_get_map_query_results_by_map_id',
                        mapId: mapId,
                        limit: limit,
                        offset: offset
                    },
                    success: function(response) {
                        var decoded = $.parseJSON(response);
                        var countingResultsHolder = $('.rows_count_progress');

                        if (decoded.success) {
                            $.merge(window.mapResults, decoded.result);
                            $.merge(results, decoded.result);
                        }
                    },
                    error: function(xhr, status, error) {

                    },
                    complete: function(xhr, status) {

                    }
                })
            );
        }

        return $.when.apply($, promises).then(function() {
            return results;
        });
    }

    function nextOptionsPage() {
        window.apiFieldsOnPagination = true;
        window.possibleTagsOnLoad = true;
        window.spinner.show();

        $('.accordion-body.api-processing-holder .api-spinner-holder').addClass('api-processing');
        $('.available_options .api-processing-holder .api-spinner-holder').addClass('api-processing');

        var mapId = $_GET('active_mapping');

        var rows_count = $('.rows_count').text();
        var search_value = $('#inputFiledSearchOption').find('input[type="text"]').val();
        var pageNumber = $(this).data('page');
        var offset = pageNumber - 1;
        var direction = $(this).data('direction');

        var count = window.mapResults.length;

        var data = {
            action: 'wp2l_get_available_options_data',
            mapId: mapId,
            count: count,
            pageNumber: pageNumber,
            mapResult: window.mapResults[offset]
        };

        $.post(ajaxurl, data, function (response) {
            var decoded = $.parseJSON(response);
            var options_wrapper = $('.available_options');
            options_wrapper.html(decoded.availableOptions);

            var prevBtn = options_wrapper.find('.prev');
            var nextBtn = options_wrapper.find('.next');

            if (prevBtn.data('page') >= 1) {
                prevBtn.attr('disabled', false);
            } else {
                prevBtn.attr('disabled', true);
            }

            if (nextBtn.data('page') > rows_count) {
                nextBtn.attr('disabled', true);
            } else {
                nextBtn.attr('disabled', false);
            }

            // prevBtn.on('click', nextOptionsPage);
            // nextBtn.on('click', nextOptionsPage);

            options_wrapper.find('.rows_count').text(rows_count);

            if (search_value) {
                var search_field = options_wrapper.find('#inputFiledSearchOption input[type="text"]');
                search_field.val(search_value);
                search_field.change();
            }

            var new_options = options_wrapper.find('.available_option > label');
            var data = [];

            $.each(new_options,function (index, label) {
                data[data.length] = $(label).text();
            });

            updateApiFields(data, true);

            updateOptinFromCondition();

            getUsersTagsFromKlickTipp(null);

            updatePossibleTags();

            updateManuallySelectedTags();

            loadPossibleTagsCloud(null);

            window.apiFieldsOnPagination = false;

            $('.accordion-body.api-processing-holder .api-spinner-holder').removeClass('api-processing');
            $('.available_options .api-processing-holder .api-spinner-holder').removeClass('api-processing');

            window.spinner.hide();
        }, 'html');
    }

    function updateApiFields(data, empty_api_field = false) {
        var api_fields = $('.api-field');
        var new_select_list = document.createDocumentFragment();

        $.each(data, function (key, value) {
            var option = $('<option>');
            option.val(value);
            option.text(value);

            new_select_list.appendChild(option[0]);
        });

        $.each(api_fields, function (index, item) {
            var select = $(item);
            var api_options = select.data('api-option');

            select.empty();
            select.append(new_select_list.cloneNode(true));

            if (undefined !== api_options['table_columns']) {
                if (empty_api_field) {
                    select.closest('.api_field_box').find('.token').remove();
                }

                $.each(api_options['table_columns'], function (index, val) {
                    selectApiFieldValue(select, val);
                });
            }
        });

        window.apiFieldsOnLoad = false;
    }

    function loadConditions(types) {

        $.each(types, function (index, type) {
            var saved_conditions = $('.' + type + '-conditions-wrapper .conditions-list').data('saved-value');
            var add_new_condition_btn = $('.' + type + '-conditions-wrapper .add_new_condition');

            if ('tags-detach' === type) {
                add_new_condition_btn = $('.' + type + '-conditions-wrapper .add_new_detach_condition');
            }

            $.each(saved_conditions, function (index, condition_data) {
                add_new_condition_btn.click();

                var last_added = $('.' + type + '-conditions-wrapper .conditions-list .condition').last();
                var select = last_added.find('.options_where');

                selectApiFieldValue(select, condition_data.option);

                last_added.find('.field_value').text(condition_data.option);
                last_added.find('select[name="operator"]').val(condition_data.operator);
                last_added.find('select[name="' + type + '"]').val(condition_data.connectTo);
                last_added.find('input[name="string"]').val(condition_data.string);

                if ('tags' === type) {
                    // selectTagsFromConnectedOptions(condition_data);
                }
            });
        });

        $('.options_where').tokenize2({
            tokensMaxItems: 1,
            searchFromStart: false
        });
    }

    function loadSeparators() {

        var saved_separators = $('.separators-list').data('saved-value');
        var add_new_separator_btn = $('.add_new_separator');

        $.each(saved_separators, function (index, separator_data) {
            add_new_separator_btn.click();

            var last_added = $('.separators-list .separator-wrapper').last();

            last_added.find('input[name="separator"]').val(separator_data.separator);

            var select = last_added.find('.options_where');

            $.each(separator_data.option, function (index, item) {
                selectApiFieldValue(select, item);
            });

            last_added.find('.options_where').tokenize2({
                searchFromStart: false
            });
        });
    }

    function loadConnectedOptions() {
        var tags_option = $('.connected-options-wrapper .options-list');
        var tags_concat_option = $('.connected-options-wrapper .options-concat-list');

        var saved_options = tags_option.data('saved-value');
        var saved_concat_options = tags_concat_option.data('saved-value');

        var template = Handlebars.compile($('#wp2l-api-tag-options')[0].innerHTML);
        var available_options = $('.available_options .available_option > label');
        var options = [];

        $.each(available_options,function (index, label) {
            options[options.length] = $(label).data('table-column');
        });

        tags_option.append(template({
            availableOptions: options
        }));

        tags_concat_option.append(template({
            availableOptions: options
        }));

        $.each(saved_options, function (index, option) {
            tags_option.find('option[value="' + option + '"]').attr('selected', true);
        });

        $.each(saved_concat_options, function (index, option) {
            tags_concat_option.find('option[value="' + option + '"]').attr('selected', true);
        });

        $('.options-list').tokenize2({searchFromStart: false});
        $('.options-concat-list').tokenize2({searchFromStart: false});
    }

    function updateManuallySelectedTags() {

        var savedMapInput = $('input.mapping');
        var savedMapOnLoad = $.parseJSON(savedMapInput.val());
        var savedMapNewData = $.parseJSON(savedMapInput.data('new_value'));
        var saved_map = savedMapOnLoad;

        if (!window.manuallySelectedTagsOnLoad && savedMapNewData) {
            saved_map = savedMapNewData;
        }

        if (saved_map) {
            var tags_cloud = $('.tags-cloud');

            if (saved_map.manually_selected_tags) {
                $.each(saved_map.manually_selected_tags.tag_ids, function (index, tag_id) {
                    var checkbox = tags_cloud.find('input[id="' + tag_id + '"]');

                    if (false) {
                        if (!checkbox.is(":checked")) {
                            checkbox.trigger('click');
                        }
                    }

                })
            }
        }
    }

    function getUsersTagsFromKlickTipp(email, cb) {
        if (null === email) {
            var email = $('.api-fields-wrapper #api_email .token > span', document.body).data('value');
        }

        var data = {
            action: 'wp2l_get_subscriber_tags_from_klicktipp',
            email: email
        };

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);
                var existed_tags_wrapper = $('.existed-tags-wrapper');

                window.currentUserKTTag = [];

                if (decoded.success) {

                    existed_tags_wrapper.empty();

                    $.each(decoded.tags, function (index, tag_id) {
                        var tag_data = {
                            id: tag_id,
                            text: $('.tags-cloud input[id="' + tag_id + '"]').val()
                        };

                        window.currentUserKTTag.push(tag_id);

                        existed_tags_wrapper.append(createTag(tag_data));
                    });

                    if (typeof cb === 'function') {
                        cb();
                    }

                } else {
                    existed_tags_wrapper.html( $.parseHTML( decoded.message ) );

                    if (typeof cb === 'function') {
                        cb();
                    }
                }
            }
        );
    }

    /**
     *
     *
     * @param condition_data
     */
    function selectTagsFromConnectedOptions(condition_data) {
        if (condition_data) {
            var tags_wrapper = $('.selected-tags-wrapper');
            var option_value = $('.available_option label[data-table-column="' + condition_data.option + '"]').data('value');
            var tag_name = $('.tags-cloud input[type="checkbox"][id="' + condition_data.connectTo + '"]').val();

            var tag_data = {
                id: condition_data.connectTo,
                text: tag_name
            };

            var alreadySelected = tags_wrapper.find('.selected-tag[data-tag-id="' + tag_data.id + '"]');

            if (option_value && alreadySelected.length < 1 && tag_data.id > 0 && undefined !== tag_data.text) {
                if (prepareCondition(option_value, condition_data)) {
                    tags_wrapper.append(createTag(tag_data));
                }
            }
        }
    }

    function selectTags() {
        var connected_for_tags = $('.connected-options-wrapper .options-list option:selected');

        $.each(connected_for_tags, function(i, field) {
            var table_column = $(field).val();
            var option = $('.available_option label[data-table-column="' + table_column + '"]');
            var separators = getSeparartors(table_column);

            if (option.length > 0) {
                $.each(option, function (index, opt) {
//                    console.log(opt);

                    var tag_text = $(opt).data('value');
                    var tags_names = [];

                    if (typeof separators !== 'undefined' && separators.length > 0) {
                        tags_names = multiSplit(tag_text, separators);
                    } else {
                        tags_names.push(tag_text);
                    }

                    if (false) {
                        $.each(tags_names, function (index, item) {
                            var tag = getExistedTag(item);

                            if (!tag) {
                                tag = createNewTag(item);
                            }

                            if (false) {
                                if (tag) {
                                    tag.trigger('click');
                                }
                            }
                        });
                    }
                });
            }
        });
    }

    function transferDataToKlickTipPromise() {
        window.transferedData = [];
        window.transferedDataCount = 0;

        var currentMap = JSON.stringify(compileMapToAPIObject());
        var iterations = window.mapResultsIterations;
        var offset = 0;
        // var limit = 2000;
        var limit = iterationLimit;
        var mapId = $_GET('active_mapping');
        var promises = [];
        var results = [];

        for (var i = 0; i < iterations; i++) {
            offset = limit * i;

            promises.push(
                $.ajax({
                    type: 'post',
                    url: ajaxurl,
                    async: false,
                    data: {
                        action: 'wp2l_transfer_all_data_to_klicktip_bg',
                        mapId: mapId,
                        limit: limit,
                        offset: offset,
                        map: currentMap
                    },
                    success: function(response) {
                        var decoded = $.parseJSON(response);

                        if (decoded.success) {
                            $.merge(window.transferedData, decoded.result);
                            window.transferedDataCount = window.transferedDataCount + decoded.count;
                            $.merge(results, decoded.result);
                        }
                    },
                    error: function(xhr, status, error) {

                    },
                    complete: function(xhr, status) {

                    }
                })
            );
        }

        return $.when.apply($, promises).then(function() {
            return results;
        });
    }

    function prepareDataForKlickTipPromise() {
        window.preparedForTransfer = [];
        window.preparedForTransferCount = 0;

        var currentMap = JSON.stringify(compileMapToAPIObject());
        var iterations = window.mapResultsIterations;
        var offset = 0;
        var limit = iterationLimit;
        var mapId = $_GET('active_mapping');
        var promises = [];
        var results = [];

        saveNewPrefixesValues();

        var global_tag_prefix = $('#globalTagPrefix').val();

        for (var i = 0; i < iterations; i++) {
            offset = limit * i;

            promises.push(
                $.ajax({
                    type: 'post',
                    url: ajaxurl,
                    async: false,
                    data: {
                        action: 'wp2l_prepare_data_for_klicktipp_bg',
                        mapId: mapId,
                        limit: limit,
                        offset: offset,
                        global_tag_prefix: global_tag_prefix,
                        map: currentMap
                    },
                    success: function(response) {
                        var decoded = $.parseJSON(response);

                        if (decoded.success) {
                            $.merge(window.preparedForTransfer, decoded.result);
                            window.preparedForTransferCount = window.preparedForTransferCount + decoded.count;
                            $.merge(results, decoded.result);
                        }
                    },
                    error: function(xhr, status, error) {

                    },
                    complete: function(xhr, status) {

                    }
                })
            );
        }

        return $.when.apply($, promises).then(function() {
            return results;
        });
    }

    function getTransferModalDataInfoPromise() {
        var mapId = $_GET('active_mapping');

        return $.ajax({
            url: ajaxurl,
            method: 'post',
            data: {
                mapId: mapId,
                action: 'wp2l_get_transfer_modal_data_info'
            },
            success: function (response) {},
            error: function (xhr, status, error) {
                console.log(xhr);
                console.log(status);
                console.log(error);
            },
            complete: function (xhr, status) {
            }
        });
    }

    function updateFieldDatApiOption (activeField, cb) {

        var activeFieldBody = activeField.parents('.api_field_body');
        var activeFieldSelect = activeFieldBody.find('select.api-field');
        var activeFieldPrev = activeFieldSelect.data('api-option');
        var activeFieldName = activeFieldSelect.attr('name');

        if (!window.apiFieldsOnLoad && activeFieldName) {
            var options = activeFieldBody.find('.api-field option:selected');

            var fieldsSelected = {
                table_columns: {}
            };

            var selected_table_columns = [];

            $.each(options, function(i, option) {
                selected_table_columns.push($(option).val().split(' ')[0]);
            });

            if (selected_table_columns.length > 0) {
                for (var j = 0; j < selected_table_columns.length; j++) {
                    fieldsSelected.table_columns[j] = selected_table_columns[j];
                }
            }

            if (activeFieldBody.find('.field-type').val()) {
                fieldsSelected.type = activeFieldBody.find('.field-type').val();
            }

            activeFieldSelect.data('api-option', fieldsSelected);
        }

        if (typeof cb === 'function') {
            cb();
        }
    }

    function compileMapToAPIObject() {
        var fields = $('.api-fields-wrapper select.api-field');

        var connected_for_tags = $('.connected-options-wrapper .options-list option:selected');
        var connected_for_tags_concat = $('.connected-options-wrapper .options-concat-list option:selected');
        var manually_selected_tags = $('.tags-cloud input:checked');
        var separators = $('.separators-list .separator-wrapper');
        var optins_conditions = $('.optins-conditions-wrapper .conditions-list .condition');
        var tags_conditions = $('.tags-conditions-wrapper .conditions-list .condition');
        var tags_detach_conditions = $('.tags-detach-conditions-wrapper .conditions-list .condition');
        var detach_tags = $('.detach-tags-wrapper-selection input[type="checkbox"]:checked');
        var tags_prefix = $('#mapTagPrefix').val();

        var api = {
            default_optin: $('.api-optins-wrapper .optins-list').val()
        };

        api.fields = {};
        $.each(fields, function(i, field) {
            var options = $(field).find('option:selected');
            var attr_name = $(field).attr('name');

            if (undefined === api.fields[attr_name]) {
                api.fields[attr_name] = {
                    table_columns: [],
                    type: $(field).parent().find('.field-type').val()
                };
            }

            $.each(options, function(i, option) {
                api.fields[attr_name].table_columns[api.fields[attr_name].table_columns.length] = $(option).val().split(' ')[0];
            });
        });

        api.conditions = {
            global: [],
            optins: [],
            tags: [],
            detach_tags: []
        };

        $.each(optins_conditions, function (index, item) {
            var condition = $(item);
            var data = {
                option: condition.find('select[name="option"] option:selected').val(),
                operator: condition.find('select[name="operator"]').val(),
                connectTo: condition.find('select[name="optins"]').val(),
                string: condition.find('input[name="string"]').val(),
            };

            api.conditions.optins.push(data);
        });

        $.each(tags_conditions, function (index, item) {
            var condition = $(item);
            var data = {
                option: condition.find('select[name="option"] option:selected').val(),
                operator: condition.find('select[name="operator"]').val(),
                connectTo: condition.find('select[name="tags"]').val(),
                string: condition.find('input[name="string"]').val(),
            };

            api.conditions.tags.push(data);
        });

        api.manually_selected_tags = {
            tag_ids: []
        };
        $.each(manually_selected_tags, function (index, item) {
            api.manually_selected_tags.tag_ids.push($(item).attr('id'));
        });

        $.each(tags_detach_conditions, function (index, item) {

            var condition = $(item);
            var data = {
                option: condition.find('select[name="option"] option:selected').val(),
                operator: condition.find('select[name="operator"]').val(),
                connectTo: condition.find('select[name="tags-detach"]').val(),
                string: condition.find('input[name="string"]').val(),
            };

            api.conditions.detach_tags.push(data);
        });

        api.connected_for_tags = {
            tags: [],
            tags_concat: [],
            separators: []
        };

        $.each(connected_for_tags, function(i, field) {
            api.connected_for_tags.tags.push($(field).val());
        });

        $.each(connected_for_tags_concat, function(i, field) {
            api.connected_for_tags.tags_concat.push($(field).val());
        });

        $.each(separators, function(i, field) {
            var separator_wrapper = $(field);
            var selected_options = separator_wrapper.find('.options_where option:selected');
            var data = {
                separator: separator_wrapper.find('input[name="separator"]').val(),
                option: []
            };

            $.each(selected_options, function (index, option) {
                data.option.push($(option).val());
            });

            api.connected_for_tags.separators.push(data);
        });

        api.detach_tags = {
            tag_ids: []
        };
        $.each(detach_tags, function (index, item) {
            api.detach_tags.tag_ids.push($(item).val());
        });

        api.tags_prefix = tags_prefix;

        return api;
    }

    function transferCurrentToKlickTipp() {
        $('.accordion-body.api-processing-holder .api-spinner-holder').addClass('api-processing');

        var mapId = $_GET('active_mapping');
        var currentMap = JSON.stringify(compileMapToAPIObject());
        var offset = $('.options-buttons-wrapper .prev.button').data('page');
        var email = $('.api-fields-wrapper #api_email .token > span').data('value');
        var currentUserData = window.mapResults[offset];

        var global_tag_prefix = $('#globalTagPrefix').val();

        var data = {
            action: 'wp2l_transfer_current_data_to_klicktip_bg',
            mapId: mapId,
            email: email,
            mapResult: currentUserData,
            global_tag_prefix: global_tag_prefix,
            map: currentMap
        };

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    var modal = $('.transfer-data-modal');

                    modal.find('.transfered-data .total').text(decoded.added_subscribers);
                    modal.find('.updated-data .total').text(decoded.existed_subscribers);
                    modal.find('.total-transferred-data .total').text(decoded.total_transferred);

                    $('#btnTransferData').data('last-transfer', decoded.last_transferred_time);

                    // Statistics
                    modal.find('.last-transferred .total').text(decoded.last_transferred_time);
                    modal.find('.all-transferred .total').text(decoded.totally_all);
                    modal.find('.unique-transferred .total').text(decoded.totally_unique);

                    updateExistedTagFieldsetList(function() {
                        getUsersTagsFromKlickTipp(null, function() {
                            loadPossibleTagsCloud(null, function() {
                                $('.accordion-body.api-processing-holder .api-spinner-holder').removeClass('api-processing');
                            })
                        });
                    });

                    // loadPossibleTagsCloud();
                } else {
                    alert(decoded.message);
                    $('.accordion-body.api-processing-holder .api-spinner-holder').removeClass('api-processing');
                }

                setTimeout(function() {
                    $('.transfer-data-modal .api-processing-holder .api-spinner-holder').removeClass('api-processing');
                }, 1000);
            }
        );
    }

    function updateExistedTagFieldsetList(cb) {
        var mapId = $_GET('active_mapping');
        var currentMap = JSON.stringify(compileMapToAPIObject());

        var data = {
            action: 'wp2l_update_existed_tag_fieldset_list',
            mapId: mapId,
            map: currentMap
        };

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    var tagsList = $('.tags-wrapper');
                    var detachTagsList = $('.detach-tags-wrapper-selection');

                    tagsList.html(decoded.tags_list);
                    detachTagsList.html(decoded.detach_tags_list);

                    if (typeof cb === 'function') {
                        cb();
                    }


                } else {
                    alert(decoded.message);

                    if (typeof cb === 'function') {
                        cb();
                    }
                }
            }
        );
    }

    function transferInformationToKlickTipp(map_id, email = null, offset = null ) {

        var data = {
            action: 'wp2l_transfer_to_klicktipp',
            map_id: map_id,
            email: email,
            offset: offset
        };

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    var modal = $('.transfer-data-modal');

                    modal.find('.transfered-data .total').text(decoded.added_subscribers);
                    modal.find('.updated-data .total').text(decoded.existed_subscribers);
                    modal.find('.total-transferred-data .total').text(decoded.total_transferred);

                    $('#btnTransferData').data('last-transfer', decoded.last_transferred_time);

                    // Statistics
                    modal.find('.last-transferred .total').text(decoded.last_transferred_time);
                    modal.find('.all-transferred .total').text(decoded.totally_all);
                    modal.find('.unique-transferred .total').text(decoded.totally_unique);

                    getUsersTagsFromKlickTipp(null);
                    unblockTransferModal();
                } else {
                    alert(decoded.message);
                    unblockTransferModal();
                }
            }
        );
    }

    function filterAvailableTags(cloud, value) {
        value = value.toLowerCase();

        $.each(cloud, function (index, item) {
            var parent = $(item).parent();
            var tag_name = $(item).data('name') + '';

            if (tag_name.search(new RegExp(value, 'i')) !== -1) {
                parent.show();
            } else {
                parent.hide();
            }
        });
    }

    function updateTagsLists(type, tags) {
        var tags_list = $('.tags-cloud');
        var detach_tags_list = $('.detach-tags-wrapper-selection');
        var existedTags = tags_list.data('tags-cloud');

        if ('add' === type) {
            $.each(tags, function (index, tag) {
                var fieldset = $('<fieldset>');
                var input = $('<input id="' + tag.tag_id + '" type="checkbox" value="' + tag.tag_name + '" data-name="'+tag.tag_name+'">');
                var label = $('<label for="' + tag.tag_id + '">' + tag.tag_name + '</label>');

                existedTags[tag.tag_id] = tag.tag_name;
                tags_list.data('tags-cloud',  existedTags);

                fieldset.append(input, label);

                tags_list.prepend(fieldset);

                var detachFieldset = $('<fieldset>');
                var detachInput = $('<input id="detach_' + tag.tag_id + '" type="checkbox" value="' + tag.tag_id + '" data-name="'+tag.tag_name+'">');
                var detachLabel = $('<label for="detach_' + tag.tag_id + '">' + tag.tag_name + '</label>');

                detachFieldset.append(detachInput, detachLabel);

                detach_tags_list.prepend(detachFieldset);
            });
        } else if ('remove' === type) {
            var removed_tags = $('.remove-tags-cloud');
            var selected_tags = $('.selected-tags-wrapper');
            var selected_tags_cloud = $('.selected-tags-cloud-wrapper');

            $.each(tags, function (index, tag_id) {
                tags_list.find('input[id="' + tag_id + '"]').parent().remove();
                detach_tags_list.find('input[id="detach_' + tag_id + '"]').parent().remove();
                removed_tags.find('input[value="' + tag_id + '"]').parent().remove();
                selected_tags.find('.selected-tag[data-tag-id="' + tag_id + '"]').remove();
                selected_tags_cloud.find('.selected-tag[data-tag-id="' + tag_id + '"]').remove();
            });
        }
    }

    function displayNotice(response) {
        var body = $('#wpbody-content');
        var responseBlock = $('<div id="setting-error-settings_updated" class="response-message notice is-dismissible"><p><strong></strong></p></div>');
        var dissmis_btn = $('<button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button>');

        responseBlock.append(dissmis_btn);
        body.parent().prepend(responseBlock);

        if (1 === response.status) {
            responseBlock.addClass('notice-success');
        } else {
            responseBlock.addClass('notice-error');
        }

        responseBlock.find('p strong').text(response.message);

        $('.notice-dismiss').on('click', function() {
            $(this).parent().remove();
        });
    }

    function createPossibleTag(data) {
        var tag = $('<div class="selected-tag">');
        tag.text(data.text);
        tag.attr('data-tag-id', data.id);

        if (data.tagClass) {
            tag.attr('class', data.tagClass);
        }

        return tag;
    }

    function createTag(data) {
        var tag = $('<div class="selected-tag">');
        var close_icon = $('<span class="tag-close-btn">');

        tag.text(data.text);
        tag.attr('data-tag-id', data.id);

        if (data.tagClass) {
            tag.attr('class', data.tagClass);
        }

        tag.append(close_icon);

        close_icon.on('click', function () {
            var parent = $(this).parent();
            var tag_id = parent.attr('data-tag-id');
            var existed_wrapper = $(this).closest('.existed-tags-wrapper');

            if (existed_wrapper.length <= 0) {
                var tags_wrapper = $('.tags-cloud');
                tags_wrapper.find('input[id="' + tag_id + '"]').prop('checked', false);
                parent.remove();
            } else {
                detachSubscriberFromTag(tag_id, parent);
            }
        });

        return tag;
    }
    
    function selectApiFieldValue(select, value) {
        var parent_wrapper = select.closest('.api_field_box');
        var fieldInput = parent_wrapper.find('li.token-search input');

        fieldInput.val(value);
        fieldInput.trigger('click');
        fieldInput.trigger('keyup');
        $('.tokenize-dropdown').filter('.dropdown').find('.dropdown-item').trigger('mousedown');

        fieldInput.val('');
        fieldInput.trigger('click');
        fieldInput.trigger('keyup');

        parent_wrapper.find('.tokenize').trigger('focusin');
        parent_wrapper.find('.tokenize').trigger('focusout');
    }

    function updateOptinFromCondition() {
        var saved_conditions = $('.optins-conditions-wrapper .conditions-list').data('saved-value');
        var optins = $('.optins-list');
        var active_optin = $('.active-optin .active-optin-wrapper');
        var template = Handlebars.compile($('#wp2l-api-default-optin-text')[0].innerHTML);

        active_optin.text(template);

        $.each(saved_conditions, function (index, condition_data) {
            var option_value = $('.available_option label[data-table-column="' + condition_data.option + '"]').data('value');

            if (prepareCondition(option_value, condition_data)) {
                active_optin.text(optins.find('option[value="' + condition_data.connectTo + '"]').text());
                //optins.val(condition_data.connectTo);
                return false;
            } else {
                if (index == Object.entries(saved_conditions).length - 1) {
                    //optins.find('option').first().prop('selected', true);
                    active_optin.text(optins.find('option:selected').text());
                }
            }
        })
    }

    function prepareCondition(option_value, condition_data) {
        var condition = false;

        var valueType = $.type(option_value);

        if ('number' === valueType) {
            option_value = option_value.toString();
        }

        switch (condition_data.operator) {
            case 'like':
                if (option_value === condition_data.string) {
                    condition = true;
                }
                break;
            case 'not-like':
                if (option_value !== condition_data.string) {
                    condition = true;
                }
                break;
            case 'contains':
                if (option_value.indexOf(condition_data.string) !== -1) {
                    condition = true;
                }
                break;
            case 'not contains':
                if (option_value.indexOf(condition_data.string) > -1) {
                    condition = true;
                }
                break;
            case 'bigger as':
                if (parseFloat(option_value) > parseFloat(condition_data.string)) {
                    condition = true;
                }
                break;
            case 'smaller as':
                if (parseFloat(option_value) < parseFloat(condition_data.string)) {
                    condition = true;
                }
                break;
        }

        return condition;
    }

    function getExistedTagByName(tag) {
        var existedTags = $('#tags-cloud-options').data('tags-cloud');
        var tagLower = tag.toLowerCase();

        for (var tag_id in existedTags) {
            var existedTagLower = existedTags[tag_id].toLowerCase();

            if ($.trim(tagLower) === $.trim(existedTagLower)) {

                var data = {
                    id: tag_id,
                    text: tag
                };

                return data;
            }
        }

        return false;
    }

    function getExistedTag (tag_text) {
        var tag = $('.tags-cloud input[value="' + tag_text + '"]');

        if (tag.length > 0) {
            return tag;
        }

        return false;
    }

    function createNewTag(tag_text) {
        var input = $('.create-tag-wrapper input');

        input.val(tag_text);
        createNotAprovedTag(tag_text);

        return getExistedTag(tag_text);
    }

    function createNotAprovedTag(tag_text) {
        var cloud = $('.tags-cloud');
        var fieldset = $('<fieldset>');
        var input = $('<input type="checkbox" value="' + tag_text + '">');
        var label = $('<label>' + tag_text + '</label>');

        fieldset.append(input, label);
        cloud.append(fieldset);
    }

    function getSeparartors(table_column) {
        var separators = $('.separators-list .separator-wrapper');
        var found_separators = [];

        $.each(separators, function (index, item) {
            var separator = $(item);
            var selected_options = separator.find('.options_where option:selected');

            $.each(selected_options, function (key, option) {
                if ($(option).val() === table_column) {
                    found_separators.push(separator.find('input[name="separator"]').val());
                }
            });
        });

        return found_separators;
    }

    function multiSplit(str, delimiter) {
        if (!(delimiter instanceof Array)) {
            return str.split(delimiter);
        }

        if (!delimiter || delimiter.length == 0) {
            return [str];
        }

        var hashSet = new Set(delimiter);

        if (hashSet.has("")) {
            return str.split("");
        }

        var lastIndex = 0;
        var result = [];

        for(var i = 0;i<str.length;i++) {
            if (hashSet.has(str[i])){
                result.push(str.substring(lastIndex,i).trim());
                lastIndex = i+1;
            }
        }

        result.push(str.substring(lastIndex).trim());

        return result;
    }

    function prepareDataForTransfer(map_id) {
        var current_map = JSON.stringify(compileMapToAPIObject());

        var data = {
            action: 'wp2l_prepare_data_for_klicktipp',
            map_id: map_id,
            map: current_map
        };

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    var modal = $('.transfer-data-modal'),
                        noticeHolder = modal.find('.notice_holder'),
                        transfer_current_btn = $('#transferCurrent'),
                        transfer_all_bg_btn = $('#transferAllBg');

                    modal.find('.available-data .total').text(decoded.available_users);

                    // Statistics
                    modal.find('.last-transferred .total').text(decoded.last_transfered);
                    modal.find('.all-transferred .total').text(decoded.totally_all);
                    modal.find('.unique-transferred .total').text(decoded.totally_unique);
                    modal.find('.cron-local .total').text(decoded.last_transfered_cron);
                    modal.find('.cron-unix .total').text(decoded.last_transfered_cron_unix);

                    if ( decoded.notice ) {
                        noticeHolder.html(decoded.notice);
                    }

                    if (0 === decoded.available_users) {
                        transfer_current_btn.prop('disabled', true);
                        transfer_all_bg_btn.prop('disabled', true);
                    } else {

                    }

                    unblockTransferModal();
                } else {
                    alert('Something went wrong.');

                    unblockTransferModal();
                }
            }
        );
    }

    function detachSubscriberFromTag(tag_id, tag_wrapper) {
        $('.accordion-body.api-processing-holder .api-spinner-holder').addClass('api-processing');
        var email = $('.api-fields-wrapper #api_email .token > span').data('value');

        var data = {
            action: 'wp2l_detach_from_tag',
            tag_id: tag_id,
            email: email
        };

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    tag_wrapper.remove();

                    loadPossibleTagsCloud(email, function() {
                        $('.accordion-body.api-processing-holder .api-spinner-holder').removeClass('api-processing');
                    });
                } else {
                    existed_tags_wrapper.text('Something went wrong.');

                    loadPossibleTagsCloud(email, function() {
                        $('.accordion-body.api-processing-holder .api-spinner-holder').removeClass('api-processing');
                    });
                }
            }
        );
    }

    function updatePossibleTags() {

        return false;

        var saved_conditions = $('.tags-conditions-wrapper .conditions-list').data('saved-value');

        $('.selected-tags-wrapper').empty();
        $(".tags-cloud input:checked").prop("checked", false);

        $.each(saved_conditions, function (index, condition_data) {
            selectTagsFromConnectedOptions(condition_data);
        });

        selectTags();
    }

    function preventLoosingData() {
        var active_tab_name = $.trim($('.nav-tab-active').text());
        var isSameVersion = true;
        var saved_map = $('input.mapping').val();
        var current_map = '';
        var map_builder_form = $('#map-generator');
        var api_settings_form = $('.map2api_body');

        if (api_settings_form.is(':visible') || map_builder_form.is(':visible')) {
            if ('Map to API' === active_tab_name) {
                current_map = JSON.stringify(compileMapToAPIObject());
            } else {
                return true;
            }

            if (saved_map !== current_map) {
                isSameVersion = false;
            }
        }

        return isSameVersion;
    }

    function blockMapToApi() {
        blockElement($('#active-optin-holder'));
        blockElement($('#existed-tags-holder'));
        blockElement($('#selected-tags-holder'));
    }

    function unblockMapToApi() {
        setTimeout(function () {
            unblockElement($('#active-optin-holder'));
            unblockElement($('#existed-tags-holder'));
            unblockElement($('#selected-tags-holder'));
        }, 200);
    }

    function blockTransferModal() {
        blockElement($('.transfer-data-modal .main-wrapper'));
        blockElement($('.transfer-data-modal .buttons-wrapper'));
    }

    function unblockTransferModal() {
        setTimeout(function () {
            unblockElement($('.transfer-data-modal .main-wrapper'));
            unblockElement($('.transfer-data-modal .buttons-wrapper'));
        }, 200);
    }

    /**
     * Block element
     * @param el
     */
    function blockElement(el) {
        if ( ! isElementBlocked( el ) ) {
            el.addClass( 'processing' ).block( {
                message: null,
                overlayCSS: {
                    background: '#fff',
                    opacity: 0.6
                }
            } );
        }
    }

    function unblockElement(el) {
        el.removeClass( 'processing' ).unblock();
    }

    function isElementBlocked(el) {
        return el.is( '.processing' ) || el.parents( '.processing' ).length;
    }

    function $_GET(param) {
        var vars = {};
        window.location.href.replace( location.hash, '' ).replace(
            /[?&]+([^=&]+)=?([^&]*)?/gi, // regexp
            function( m, key, value ) { // callback
                vars[key] = value !== undefined ? value : '';
            }
        );

        if ( param ) {
            return vars[param] ? vars[param] : null;
        }
        return vars;
    }
})(jQuery);