(function ($) {

    $(document).ready(function () {
        var availableMapsTable = $('.available-maps__table');
        var importMapsTable = $('#import-maps-from-server-table');
        var exportMapsTable = $('#export-maps_table');

        if (availableMapsTable.length > 0) {
            availableMapsTable.floatThead({
                scrollContainer: function(table){
                    return table.closest('.available-maps_table-wrap');
                }
            });
        }

        if (importMapsTable.length > 0) {
            importMapsTable.floatThead({
                scrollContainer: function(table){
                    return table.closest('.import-maps-from-server-table-wrap');
                }
            });
        }

        if (exportMapsTable.length > 0) {
            exportMapsTable.floatThead({
                scrollContainer: function(table){
                    return table.closest('.export-maps-to-server-table-wrap');
                }
            });
        }

        if (importMapsTable.length > 0 && exportMapsTable.length > 0) {
            var localMaps = exportMapsTable.find();
        }

        $('.wp2lead-tip').tipr({
            'marginAbove': -55,
            'marginBelow': 7,
            'space': 70
        });
    });

    $(document.body).on('click', '#wp2lPrepareForCron', function() {
        console.log('click #wp2lPrepareForCron');
        var mapId = $_GET('active_mapping');

        var data = {
            mapId: mapId,
            action: 'wp2l_prepare_data_for_klicktipp_for_cron'
        };

        $.ajax({
            type: 'post',
            url: ajaxurl,
            data: data,
            success: function(response) {
                console.log(response);
            }
        });
    });

    /**
     * Activate / Deactivate site
     */
    $(document.body).on('click', '#wp2lActivate, #wp2lDectivate', function() {
        var licenseEmail = $('#wp2l-license-email').val(),
            licenseKey = $('#wp2l-license-key').val(),
            action = $(this).data('action');

        if ('deactivation' === action) {
            if (!confirm("Are you sure? Without correct license key you are not be able to activate your plugin again.")) {
                return;
            }
        }

        $.ajax({
            type: 'post',
            url: ajaxurl,
            async: false,
            data: {
                action: 'wp2l_license_' + action,
                licenseEmail: licenseEmail,
                licenseKey: licenseKey
            },
            success: function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert(decoded.message);

                    window.location.reload();
                } else {
                    alert(decoded.message);
                }
            }
        });
    });

    /**
     * Activate / Deactivate site
     */
    $(document.body).on('click', '.wp2lComplete', function(e) {
        e.preventDefault();

        $.ajax({
            type: 'post',
            url: ajaxurl,
            async: false,
            data: {
                action: 'wp2l_complete_activation'
            },
            success: function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert(decoded.message);

                    window.location.reload();
                } else {
                    alert(decoded.message);
                }
            }
        });
    });

    /**
     * Remove site activation
     */
    $(document.body).on('click', '.wp2lRemove', function() {
        var licenseEmail = $('#wp2l-license-email').val(),
            licenseKey = $('#wp2l-license-key').val(),
            site = $(this).data('site');

        $.ajax({
            type: 'post',
            url: ajaxurl,
            async: false,
            data: {
                action: 'wp2l_license_removing',
                licenseEmail: licenseEmail,
                licenseKey: licenseKey,
                site: site
            },
            success: function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert(decoded.message);

                    window.location.reload();
                } else {
                    alert(decoded.message);
                }
            }
        });
    });

    /**
     * KlickTip Auth
     */
    $(document.body).on('click','#btnKlicktippSubmit',function(e) {
        e.preventDefault();

        var klicktipp = {
            username: $("input[name=settings-klicktipp-username]").val(),
            password: $("input[name=settings-klicktipp-password]").val(),
            speed: $("input[name=settings-klicktipp-speed]").val()
        };

        $.post(
            ajaxurl,
            {
                action: 'wp2l_settings_klicktipp',
                klicktipp: klicktipp
            },
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    if(decoded.auth) {
                        alert('Authorization in KlickTipp was successful!');
                    } else {
                        alert('The username or password you entered is incorrect!');
                    }
                } else {
                    alert('Something went wrong.');
                }
            });
    });

    $(document.body).on('submit', '#import-map-from-server-by-public-id-form', function(e) {
        e.preventDefault();
        var form = $("#import-map-from-server-by-public-id-form");

        var activeMapping = $_GET('active_mapping');
        var redirectMapping = '';

        if (activeMapping) {
            redirectMapping = '&active_mapping=' + activeMapping;
        }

        var mapimportids = [];
        var selectOneImport = form.find('#map-public-id').val();

        if (selectOneImport) {
            mapimportids.push({
                mapId: $.trim(selectOneImport)
            });
        }

        $.ajax({
            url: ajaxurl,
            method: 'post',
            async: false,
            data: {
                action: 'wp2l_import_maps',
                mapimportids: mapimportids
            },
            success: function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert(decoded.message);
                    window.location.href = '?page=wp2l-admin&tab=map_port' + redirectMapping ;
                } else {
                    alert(decoded.message);
                }
            }
        });
    });

    $(document.body).on('submit', '#export-maps-form', function(e) {
        var form = $("#export-maps-form");

        var activeMapping = $_GET('active_mapping');
        var redirectMapping = '';

        if (activeMapping) {
            redirectMapping = '&active_mapping=' + activeMapping;
        }

        var mapuploadids = [];
        var mapupdateids = [];
        var mapkindversion = [];

        var selectOneUpload = form.find('.map-upload:checked');
        var selectOneUpdate = form.find('.map-update:checked');
        var selectMapVersion = form.find('.map-kind-version');

        if (selectOneUpload.length > 0) {
            selectOneUpload.each(function() {
                var mapId = $(this).val();
                var mapVersion = $('#mapkindversion_' + mapId).val();
                mapuploadids.push({
                    mapId: mapId,
                    mapVersion: mapVersion
                });
            });
        }

        if (selectOneUpdate.length > 0) {
            selectOneUpdate.each(function() {
                var mapId = $(this).val();
                var mapVersion = $('#mapkindversion_' + mapId).val();
                mapupdateids.push({
                    mapId: mapId,
                    mapVersion: mapVersion
                });
            });
        }

        if (mapupdateids.length > 0 || mapuploadids.length > 0) {
            e.preventDefault();

            $.ajax({
                url: ajaxurl,
                method: 'post',
                async: false,
                data: {
                    action: 'wp2l_export_maps',
                    mapuploadids: mapuploadids,
                    mapupdateids: mapupdateids
                },
                success: function (response) {
                    var decoded = $.parseJSON(response);

                    if (decoded.success) {
                        if (decoded.mapping) {
                            $('.mapping').val(decoded.mapping);
                        }

                        alert(decoded.message);
                        window.location.href = '?page=wp2l-admin&tab=map_port' + redirectMapping ;
                    } else {
                        alert(decoded.message);
                    }
                }
            });
        }
    });

    $(document.body).on('submit', '#import-maps-from-server-form', function(e) {
        e.preventDefault();

        var form = $("#import-maps-from-server-form");
        var activeMapping = $_GET('active_mapping');
        var redirectMapping = '';

        if (activeMapping) {
            redirectMapping = '&active_mapping=' + activeMapping;
        }

        var mapimportids = [];

        var selectOneImport = form.find('.map-public-ids:checked');

        if (selectOneImport.length > 0) {
            selectOneImport.each(function() {
                var mapId = $(this).val();
                mapimportids.push({
                    mapId: mapId
                });
            });
        }

        $.ajax({
            url: ajaxurl,
            method: 'post',
            async: false,
            data: {
                action: 'wp2l_import_maps',
                mapimportids: mapimportids
            },
            success: function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert(decoded.message);
                    window.location.href = '?page=wp2l-admin&tab=map_port' + redirectMapping ;
                } else {
                    alert(decoded.message);
                }
            }
        });
    });

    $(document.body).on('submit', '#import-pending-maps-from-server-form', function(e) {
        e.preventDefault();

        var form = $("#import-pending-maps-from-server-form");
        var activeMapping = $_GET('active_mapping');
        var redirectMapping = '';

        if (activeMapping) {
            redirectMapping = '&active_mapping=' + activeMapping;
        }

        var mapimportids = [];

        var selectOneImport = form.find('.map-public-ids:checked');

        if (selectOneImport.length > 0) {
            selectOneImport.each(function() {
                var mapId = $(this).val();
                mapimportids.push({
                    mapId: mapId
                });
            });
        }

        $.ajax({
            url: ajaxurl,
            method: 'post',
            async: false,
            data: {
                action: 'wp2l_import_pending_maps',
                mapimportids: mapimportids
            },
            success: function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert(decoded.message);
                    window.location.href = '?page=wp2l-admin&tab=map_port' + redirectMapping ;
                } else {
                    alert(decoded.message);
                }
            }
        });
    });

    $(document.body).on('click', '#wp2l_select_all_import_maps', function() {
        var isChecked = $(this).prop('checked');
        var table = $(this).parents('#import-maps-from-server-table');
        var selectOneDownload = table.find('.map-public-ids');

        if (isChecked) {
            selectOneDownload.prop('checked', true);
        } else {
            selectOneDownload.prop('checked', false);
        }
    });

    $(document.body).on('click', '#export-maps_table .map-ids, #export-maps_table .map-upload, #export-maps_table .map-update', function() {
        var checkBox = $(this);
        var isChecked = $(this).prop('checked');
        var action = null;
        var checkedCount = 0;
        var checkboxes = false;
        var table = $(this).parents('#export-maps_table');

        var selectAllFile = $('#wp2l_select_all_maps');
        var selectAllUpload = $('#wp2l_select_all_mapuploadids');
        var selectAllUpdate = $('#wp2l_select_all_mapupdateids');

        var selectOneFile = table.find('.map-ids');
        var selectOneUpload = table.find('.map-upload');
        var selectOneUpdate = table.find('.map-update');

        if (checkBox.hasClass('map-upload')) {
            action = 'upload';

            checkboxes = selectOneUpload;
        } else if (checkBox.hasClass('map-update')) {
            action = 'update';

            checkboxes = selectOneUpdate;
        } else if (checkBox.hasClass('map-ids')) {
            action = 'to-file';

            checkboxes = selectOneFile;
        }

        if (checkboxes && checkboxes.length > 0) {
            checkboxes.each(function() {
                if ($(this).is(":checked")) {
                    checkedCount++;
                }
            });
        }

        if (action === 'upload') {
            if (checkedCount > 0) {
                selectAllFile.prop('checked', false).prop('disabled', true);
                selectAllUpdate.prop('checked', false).prop('disabled', true);
                selectOneFile.prop('checked', false).prop('disabled', true);
                selectOneUpdate.prop('checked', false).prop('disabled', true);
            } else {
                selectAllFile.prop('checked', false).prop('disabled', false);
                selectAllUpdate.prop('checked', false).prop('disabled', false);
                selectOneFile.prop('checked', false).prop('disabled', false);
                selectOneUpdate.prop('checked', false).prop('disabled', false);
            }
        } else if (action === 'update') {
            if (checkedCount > 0) {
                selectAllUpload.prop('checked', false).prop('disabled', true);
                selectAllFile.prop('checked', false).prop('disabled', true);
                selectOneFile.prop('checked', false).prop('disabled', true);
                selectOneUpload.prop('checked', false).prop('disabled', true);
            } else {
                selectAllUpload.prop('checked', false).prop('disabled', false);
                selectAllFile.prop('checked', false).prop('disabled', false);
                selectOneFile.prop('checked', false).prop('disabled', false);
                selectOneUpload.prop('checked', false).prop('disabled', false);
            }
        } else if (action === 'to-file') {
            if (checkedCount > 0) {
                selectAllUpload.prop('checked', false).prop('disabled', true);
                selectAllUpdate.prop('checked', false).prop('disabled', true);
                selectOneUpload.prop('checked', false).prop('disabled', true);
                selectOneUpdate.prop('checked', false).prop('disabled', true);
            } else {
                selectAllUpload.prop('checked', false).prop('disabled', false);
                selectAllUpdate.prop('checked', false).prop('disabled', false);
                selectOneUpload.prop('checked', false).prop('disabled', false);
                selectOneUpdate.prop('checked', false).prop('disabled', false);
            }
        }
    });

    $(document.body).on('click', '#wp2l_select_all_mapuploadids', function() {
        var isChecked = $(this).prop('checked');
        var table = $(this).parents('#export-maps_table');
        var selectAllUpdate = $('#wp2l_select_all_mapupdateids');
        var selectOneUpdate = table.find('.map-update');

        $(this).closest('form').find('input.map-upload').each(function() {
            $(this).prop('checked', isChecked);
        });

        if (isChecked) {
            selectAllUpdate.prop('checked', false).prop('disabled', true);
            selectOneUpdate.prop('checked', false).prop('disabled', true);
        } else {
            selectAllUpdate.prop('checked', false).prop('disabled', false);
            selectOneUpdate.prop('checked', false).prop('disabled', false);
        }
    });

    $(document.body).on('click', '#wp2l_select_all_mapupdateids', function() {
        var isChecked = $(this).prop('checked');
        var table = $(this).parents('#export-maps_table');
        var selectAllUpload = $('#wp2l_select_all_mapuploadids');
        var selectOneUpload = table.find('.map-upload');

        $(this).closest('form').find('input.map-update').each(function() {
            $(this).prop('checked', isChecked);
        });

        if (isChecked) {
            selectAllUpload.prop('checked', false).prop('disabled', true);
            selectOneUpload.prop('checked', false).prop('disabled', true);
        } else {
            selectAllUpload.prop('checked', false).prop('disabled', false);
            selectOneUpload.prop('checked', false).prop('disabled', false);
        }
    });

    // TODO - This is only for DEV purposes need to be removed
    $(document.body).on('click', '.change-license', function(e) {
        e.preventDefault();
        var licenseToTest = $(this).data('license');

        $.ajax({
            type: 'post',
            url: ajaxurl,
            async: false,
            data: {action: 'wp2l_set_fake_license_level', 'license_level': licenseToTest},

            success: function (response) {
                var licenseLevelCurrent = $('.license-level-current');
                var decoded = $.parseJSON(response);

                licenseLevelCurrent.text(decoded.license_level);

                window.location.reload();
            }
        });
    });

    $(document.body).on('click', '.wp2l-map-delete', function () {
        if (confirm('Are you sure you want to completely delete this map?')) {
            var $row = $(this).parentsUntil('tr').parent();
            var $form = $(this).parentsUntil('form').parent().first();
            var mapId = _.find($form.serializeArray(), {'name': 'map_id'}).value;

            $.post(ajaxurl, {action: 'wp2l_map_delete', map_id: mapId}, function (response) {

                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert('Map successfully deleted!');
                } else {
                    alert('Something went wrong.');
                }

                window.location.reload();
            });
        }
    });

    $(document.body).on('click', '#showMapRunnerList', function () {
        var btn = $(this);
        var openText = btn.data('open-text');
        var closeText = btn.data('close-text');

        var mapList = $(document.body).find('#map-runner__map-list');

        if (!mapList.hasClass('active')) {
            mapList.addClass('active');
            btn.text(closeText);
        } else {
            mapList.removeClass('active');
            btn.text(openText);
        }
    });

    $(document.body).on('click', '#btnShowMapToApiList', function () {
        var btn = $(this);
        var openText = btn.data('open-text');
        var closeText = btn.data('close-text');

        var mapList = $(document.body).find('#map-to-api__map-list');

        if (!mapList.hasClass('active')) {
            mapList.addClass('active');
            btn.text(closeText);
        } else {
            mapList.removeClass('active');
            btn.text(openText);
        }
    });

    $(document.body).on('click', '#btnShowMapList', function () {
        var mapList = $(document.body).find('#postbox-container-1');
        var floatThead = $(document.body).find('.floatThead-container');
        var saveMapBtn = $('#btnUpdateMapToApi');

        if(mapList.is(":hidden")) {
            $(this).val('Hide map list');

            if (window.matchMedia('(max-width: 850px)').matches) {
                mapList.append($(this));
                mapList.css({
                    position: 'absolute'
                });
            }

            mapList.show();
        } else {
            mapList.hide();
            $(this).val('Show map list');

            if (window.matchMedia('(max-width: 850px)').matches) {
                saveMapBtn.after($(this));
                mapList.css({
                    position: 'static'
                });
            }
        }

        floatThead.css('width', '100%');
    });

    // $(document.body).on('click', '#import_from_remote', function () {
    //     var data = {
    //         action: 'wp2l_maps_import_from_remote'
    //     };
    //
    //     $.post(ajaxurl, data, function(response) {
    //         var decoded = $.parseJSON(response);
    //
    //         if (decoded.success) {
    //             alert(decoded.message);
    //
    //             window.location.reload();
    //         } else {
    //             alert(decoded.message);
    //         }
    //     });
    // });

    $(document.body).on('click', '#available-maps_actions-run', function(e) {
        e.preventDefault();
        var button = $(this);

        if (button.hasClass('disabled')) {
            return false;
        }

        var action = $('#available-maps_actions');
        var actionVal = action.val();
        var actionDefault = action.find('option[value=""]');
        var mapsList = $('.available-maps_table-wrap .map_checkbox');
        var allMapsId = [];
        var selectedMapsId = [];
        var allMaps = false;

        if ('delete_all' === actionVal) {
            allMaps = true;
        }

        if (mapsList.length > 0) {
            mapsList.each(function () {
                var mapItem = $(this);
                var mapId = mapItem.val();

                allMapsId.push(mapId);

                if (mapItem.prop('checked')) {
                    selectedMapsId.push(mapId);
                }
            });
        }

        var useMaps = selectedMapsId;

        if (allMaps) {
            useMaps = allMapsId;
        }

        if (confirm('Are you sure you want to completely delete this maps?')) {
            var data = {
                action: 'wp2l_maps_actions_run',
                run: actionVal,
                maps: useMaps
            };

            $.post(ajaxurl, data, function(response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert(decoded.message);

                    window.location.reload();
                } else {
                    alert(decoded.message);
                }
            });

            actionDefault.attr('selected', true);
            action.trigger('change');
        }
    });

    $(document.body).on('change', '#available-maps_actions', function(e) {
        var action = $(this);
        var actionVal = action.val();
        var button = $('#available-maps_actions-run');

        console.log(actionVal);

        if ('' !== actionVal) {
            button.removeClass('disabled');
        } else {
            button.addClass('disabled');
        }
    });

    $(document.body).on('click', '#wp2lActivateModal', function() {
        var licenseEmail = $('#wp2l-modal-license-email').val(),
            licenseKey = $('#wp2l-modal-license-key').val();

        var unsuccessMessageLinkTemplate = Handlebars.compile($('#wp2l-license-page-link')[0].innerHTML);
        var errorMessageHolder = $(document.body).find('.error-message-holder');

        $.ajax({
            type: 'post',
            url: ajaxurl,
            async: false,
            data: {
                action: 'wp2l_modal_license_activation',
                licenseEmail: licenseEmail,
                licenseKey: licenseKey
            },
            success: function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    if (200 === decoded.status) {
                        alert(decoded.message);
                        window.location.reload();
                    } else {
                        errorMessageHolder.append('<p>'+decoded.message+'</p>');
                        errorMessageHolder.append(unsuccessMessageLinkTemplate({}));
                    }
                } else {
                    errorMessageHolder.append('<p>'+decoded.message+'</p>');
                    errorMessageHolder.append(unsuccessMessageLinkTemplate({}));
                }
            }
        });
    });

    $(document.body).on('click', '#modal-close', function() {
        var modal = $(this).parents('#modal-overlay');

        if (modal.length > 0) {
            modal.remove();
        }
    });

    $(document.body).on('click', '#license-modal-open', function() {
        var modalTemplate = Handlebars.compile($('#wp2l-simple-modal')[0].innerHTML);
        var licenseFormTemplate = Handlebars.compile($('#wp2l-license-form')[0].innerHTML);

        $('body').append(modalTemplate({}));

        var modal = $(document.body).find('#modal-overlay #content');
        modal.append(licenseFormTemplate({}));
    });

    function $_GET(param) {
        var vars = {};
        window.location.href.replace( location.hash, '' ).replace(
            /[?&]+([^=&]+)=?([^&]*)?/gi, // regexp
            function( m, key, value ) { // callback
                vars[key] = value !== undefined ? value : '';
            }
        );

        if ( param ) {
            return vars[param] ? vars[param] : null;
        }
        return vars;
    }
})(jQuery);