(function ($) {

    $(document).ready(function () {

    });

    $(document.body).on('click', '#refresh-all-bg-map-to-api', function() {
        refreshAllBgMapToApi();
    });

    function refreshAllBgMapToApi() {
        var data = {
            action: 'wp2l_refresh_all_map_to_api'
        };

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    var noticeHolder = $('#map-to-api-bg-running-inner');
                    noticeHolder.html(decoded.html);

                } else {
                    alert(decoded.message);
                }
            }
        );
    }

    $(document.body).on('click', '#terminate-all-bg-map-to-api', function() {
        var data = {
            action: 'wp2l_terminate_all_map_to_api'
        };

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert(decoded.message);
                } else {
                    alert(decoded.message);
                }
            }
        );
    });

    $(document.body).on('click', '.terminate-bg-map-to-api', function() {
        var mapId = $(this).data('map');

        var data = {
            action: 'wp2l_terminate_map_to_api',
            mapId: mapId
        };

        var activeMapping = $_GET('active_mapping');
        var activeTab = $_GET('tab');
        var redirectMapping = '';
        var redirectTab = '';

        if (activeMapping) {
            redirectMapping = '&active_mapping=' + activeMapping;
        }

        if (activeTab) {
            redirectTab = '&tab=' + activeTab;
        }

        var activePage = $_GET('page');

        var noticeHolder = $('#wp2lead-map-to-api-bg-notice .api-spinner-holder');

        noticeHolder.addClass('api-processing');

        $.post(
            ajaxurl,
            data,
            function (response) {
                var decoded = $.parseJSON(response);

                if (decoded.success) {
                    alert(decoded.message);

                    if ('wp2l-admin' === activePage) {
                        window.location.href = '?page=wp2l-admin' + redirectTab + redirectMapping;
                    } else {
                        window.location.reload();
                    }

                } else {
                    alert(decoded.message);
                    noticeHolder.removeClass('api-processing');
                }
            }
        );
    });

    function $_GET(param) {
        var vars = {};
        window.location.href.replace( location.hash, '' ).replace(
            /[?&]+([^=&]+)=?([^&]*)?/gi, // regexp
            function( m, key, value ) { // callback
                vars[key] = value !== undefined ? value : '';
            }
        );

        if ( param ) {
            return vars[param] ? vars[param] : null;
        }
        return vars;
    }

})(jQuery);