<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @since      1.0.0
 *
 * @package    Wp2leads
 * @subpackage Wp2leads/admin/partials
 */

?>

<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<div class="wrap">
    <h1>
        <?php _e('WP2Leads', 'wp2leads') ?> <?php echo $version ?>
        <?php
        if (Wp2leads_License::is_dev_allowed() && $wp2l_is_dev) {
            ?>(<?php _e('Dev mode', 'wp2leads') ?>: <?php echo $dev_version; ?>)<?php
        }
        ?>
    </h1>

    <?php settings_errors(); ?>

    <?php
    $default_tab = count($maps) ? 'map_runner' : 'map_port';
    $active_tab = isset( $_GET[ 'tab' ] ) ? $_GET[ 'tab' ] : $default_tab;
    $active_mapping = isset( $_GET[ 'active_mapping' ] ) ? '&active_mapping=' . $_GET[ 'active_mapping' ] : '';
    ?>

    <h2 class="nav-tab-wrapper">
        <a
                href="?page=wp2l-admin&tab=map_runner<?php echo $active_mapping?>"
                class="nav-tab <?php echo $active_tab == 'map_runner' ? 'nav-tab-active' : ''; ?>"
        >
            <?php _e('Map Runner', 'wp2leads') ?>
        </a>
        <a
                href="?page=wp2l-admin&tab=map_port<?php echo $active_mapping?>"
                class="nav-tab <?php echo $active_tab == 'map_port' ? 'nav-tab-active' : ''; ?>"
        >
            <?php _e('Maps', 'wp2leads') ?>
        </a>
        <a
                href="?page=wp2l-admin&tab=map_to_api<?php echo $active_mapping?>"
                class="nav-tab <?php echo $active_tab == 'map_to_api' ? 'nav-tab-active' : ''; ?>"
        >
            <?php _e('Map to API', 'wp2leads') ?>
        </a>
        <a
                href="?page=wp2l-admin&tab=statistics<?php echo $active_mapping?>"
                class="nav-tab <?php echo $active_tab == 'statistics' ? 'nav-tab-active' : ''; ?>"
        >
            <?php _e('Statistics', 'wp2leads') ?>
        </a>
        <a
                href="?page=wp2l-admin&tab=map_builder<?php echo $active_mapping?>"
                class="nav-tab <?php echo $active_tab == 'map_builder' ? 'nav-tab-active' : ''; ?>"
        >
            <?php _e('Map Builder', 'wp2leads') ?>
        </a>
        <a
                href="?page=wp2l-admin&tab=tools<?php echo $active_mapping?>"
                class="nav-tab <?php echo $active_tab == 'tools' ? 'nav-tab-active' : ''; ?>"
        >
            <?php _e('Tools', 'wp2leads') ?>
        </a>
        <a
                href="?page=wp2l-admin&tab=settings<?php echo $active_mapping?>"
                class="nav-tab <?php echo $active_tab == 'settings' ? 'nav-tab-active' : ''; ?>"
        >
            <?php _e('Settings', 'wp2leads') ?>
        </a>
    </h2>

    <?php
    switch($active_tab) {
        case "map_builder":
            if ( !empty( $_GET['active_mapping'] ) && !empty($decodedMap) ) {
                require_once dirname(__FILE__) . '/wp2leads-admin-map_builder-edit.php';
                break;
            }

            if ( !empty( $_GET['duplicate_mapping'] ) ) {
                require_once dirname(__FILE__) . '/wp2leads-admin-map_builder-duplicate.php';
                break;
            }

            require_once dirname(__FILE__) . '/wp2leads-admin-map_builder-new.php';
            break;

        case "map_to_api":
            require_once dirname(__FILE__) . '/wp2leads-admin-map_to_api.php';
            break;

        case "tools":
            require_once dirname(__FILE__) . '/wp2leads-admin-tools.php';
            break;

        case "statistics":
            require_once dirname(__FILE__) . '/wp2leads-admin-statistics.php';
            break;

        case "map_port":
            require_once dirname(__FILE__) . '/wp2leads-admin-map_port.php';
            break;

        case "settings":
            require_once dirname(__FILE__) . '/wp2leads-admin-settings.php';
            break;

        case "map_runner":
        default:
            require_once dirname(__FILE__) . '/wp2leads-admin-map_runner.php';
            break;
    }
    ?>
</div>
<?php
require_once dirname(__FILE__) .'/wp2leads-admin-handlebars-templates.php';

//$memory = (memory_get_usage()/1048576);
//
//$payment_gateways = WC()->payment_gateways->payment_gateways();
//$shipping_methods = WC()->shipping->get_shipping_methods();
?>

