<?php
/**
 * Created by PhpStorm.
 * Date: 2/4/18
 * Time: 8:37 AM
 */
?>
<form action="?page=wp2l-admin&tab=map_runner&active_mapping=8" method="get"
      style="display: inline; float: right; margin-top: 10px;">
    <input type="hidden" name="page" value="<?php echo $_GET['page'] ?>">
    <input type="hidden" name="tab" value="map_runner">
    <input type="hidden" name="active_mapping"
           value="<?php echo isset( $_GET['active_mapping'] ) ? $_GET['active_mapping'] : '' ?>">

    <?php submit_button( __( 'Run', 'wp2leads' ), 'secondary', 'update-result-limit', false, [ 'style' => "float: right; margin-left: 5px;" ] ); ?>

    <span style="float: right"><?php _e( 'Limit results to:', 'wp2leads' ) ?>
        <input type="number" name="limit" id="map-sample-results-limit"
               value="<?php echo ( isset( $_GET['limit'] ) ) ? $_GET['limit'] : 100 ?>"
               class="small-text"
        >
    </span>
</form>

<h2><?php _e( 'Map Runner', 'wp2leads' ) ?></h2>

<hr>

<div id="mapRunnerContainer" class="map-runner">
    <?php if ( ! $activeMap ): ?>
        <div id="map-runner__container">
            <div id="map-runner__body">
                <div id="map-runner__results" class="results-holder">
                    <?php require_once dirname( __FILE__ ) . '/wp2leads-admin-select-map.php'; ?>
                </div>

                <div id="map-runner__map-list" class="active">
                    <?php require_once dirname( __FILE__ ) . '/wp2leads-admin-runner-map-list.php'; ?>
                </div>
            </div>
        </div>
    <?php else: ?>
        <?php
        $cron_maps = Wp2LeadsCron::getScheduledMaps();

        if ( empty( $cron_maps[ 'map_' . $activeMap->id ] ) ) {
            $cron_status = '';
            $cron_title  = __( 'Cron not set up', 'wp2leads' );
        } else {
            $cron_status = ' disabled';
            $cron_title  = __( 'Cron disabled', 'wp2leads' );

            if ( ! empty( $cron_maps[ 'map_' . $activeMap->id ]['status'] ) ) {
                $cron_status = ' active';
                $cron_title  = __( 'Cron enabled', 'wp2leads' );
            }
        }

        if ( ! Wp2leads_License::is_map_transfer_allowed( $activeMap->id ) ) {
            $cron_status = '';
        }
        ?>
        <div id="map-runner__container" data-map-id="<?php echo $activeMap->id ?>">
            <div id="map-runner__header">
                <h3 class="title">
                        <span class="dashicons dashicons-clock<?php echo $cron_status ?>"
                              title="<?php echo $cron_title ?>"></span>
                    <?php echo stripslashes( $activeMap->name ) ?>
                </h3>

                <div class="buttons-holder">
                    <a href="?page=wp2l-admin&tab=map_runner" class="button button-primary">
                        <?php _e( 'Exit Map', 'wp2leads' ) ?>
                    </a>

                    <!--                                <button id="wp2lPrepareForCron" class="button button-primary">-->
                    <!--                                    Prepare For Cron-->
                    <!--                                </button>-->

                    <?php
                    if ( Wp2leads_License::is_action_allowed( 'duplicate_map' ) ) {
                        ?>
                        <a id="btnDuplicateMap" class="button button-primary"
                           href="?page=wp2l-admin&tab=map_builder&duplicate_mapping=<?php echo $activeMap->id ?>"
                        >
                            <?php _e( 'Duplicate Map', 'wp2leads' ) ?>
                        </a>
                        <?php
                    }
                    ?>

                    <button id="showMapRunnerList" class="button button-primary"
                            data-open-text="<?php echo __( 'Show map list', 'wp2leads' ); ?>"
                            data-close-text="<?php echo __( 'Hide map list', 'wp2leads' ); ?>">
                        <?php echo __( 'Show map list', 'wp2leads' ); ?>
                    </button>
                </div>
            </div>

            <div id="map-runner__body">
                <div id="map-runner__map-list">
                    <?php require_once dirname( __FILE__ ) . '/wp2leads-admin-runner-map-list.php'; ?>
                </div>

                <div id="map-runner__results" class="results-holder api-processing-holder" data-key-by="<?php echo $decodedMap['keyBy'] ?>">
                    <div id="wp2l-results-preview-wrap">
                        <div id="no-results">
                            <p>
                                <?php _e( 'Result loading.', 'wp2leads' ) ?>
                            </p>
                        </div>
                    </div>

                    <div class="api-spinner-holder api-processing">
                        <div class="api-spinner"></div>
                    </div>
                </div>
            </div>

        </div>
    <?php endif; ?>
</div>