<?php

if ( $activeMap ) {
    $activeMapId = '';

    if ( $_GET['tab'] == 'map_to_api' && isset( $_GET['active_mapping'] ) ) {
        global $wpdb;
        $table       = $wpdb->get_row( sprintf( "SELECT * FROM %s WHERE id=%d", $wpdb->prefix . "wp2l_maps", (int) $_GET['active_mapping'] ) );
        $api         = unserialize( $table->api );
        $info        = unserialize( $table->info );
        $activeMapId = $_GET['active_mapping'];
    }

    $connector = new Wp2leads_KlicktippConnector();
    $logged_in = $connector->login();
    $connector->get_last_error();

    if ( $logged_in ) {
        $fields = $connector->field_index();
        $tags   = (array) $connector->tag_index();
        asort( $tags, SORT_STRING | SORT_FLAG_CASE | SORT_NATURAL );
        $optins = $connector->subscription_process_index();
    }

    $is_transfer_allowed = Wp2leads_License::is_map_transfer_allowed( (int) $_GET['active_mapping'] );

//    global $wpdb;
//    $wpdb->query( "DELETE FROM $wpdb->options WHERE option_name LIKE '%wp2lead_map_to_api_results__". $activeMapId ."%'" );
}
?>

    <h2><?php _e( 'Map to API', 'wp2leads' ) ?></h2>

    <hr>

    <div id="map-to-api-message-in-progress__holder">
    </div>

<?php
if ( $activeMap && ! $is_transfer_allowed ) {
    ?>
    <div class="wp2leads-notice wp2leads-notice-warning">
        <h4><?php _e( 'Transfer Map only in paid versions', 'wp2leads' ) ?></h4>

        <p><?php _e( 'Please upgrade to Professional Version to transfer user via OWN created maps. <a href="https://wp2leads-for-klick-tipp.com/?p=7" target="_blank">Buy it</a>, or <button class="button button-small" id="license-modal-open">Enter a license</button>', 'wp2leads' ) ?></p>
    </div>
    <?php
}
?>

    <div class="map-to-api">
        <?php if ( !$activeMap ): ?>
            <div id="map-to-api__container">
                <div id="map-to-api__body">
                    <div id="map-to-api__results" class="results-holder">
                        <?php require_once dirname( __FILE__ ) . '/wp2leads-admin-select-map.php'; ?>
                    </div>

                    <div id="map-to-api__map-list" class="active">
                        <?php require_once dirname( __FILE__ ) . '/wp2leads-admin-runner-map-list.php'; ?>
                    </div>
                </div>
            </div>
        <?php else: ?>
            <?php
            $cron_maps = Wp2LeadsCron::getScheduledMaps();

            if ( empty( $cron_maps[ 'map_' . $activeMapId ] ) ) {
                $cron_status   = '';
                $cron_title    = __( 'Cron not set up', 'wp2leads' );
                $cron_checked  = '';
                $cron_selected = '';
            } else {
                $cron_status   = ' disabled';
                $cron_title    = __( 'Cron disabled', 'wp2leads' );
                $cron_checked  = '';
                $cron_selected = '';

                if ( ! empty( $cron_maps[ 'map_' . $activeMapId ]['status'] ) ) {
                    $cron_status  = ' active';
                    $cron_title   = __( 'Cron enabled', 'wp2leads' );
                    $cron_checked = 'checked';
                }

                if ( ! empty( $cron_maps[ 'map_' . $activeMapId ]['date_base'] ) ) {
                    if ( ! is_array( $cron_maps[ 'map_' . $activeMapId ]['date_base'] ) ) {
                        $cron_selected = htmlspecialchars( json_encode( array( $cron_maps[ 'map_' . $activeMapId ]['date_base'] ) ) );
                    } else {
                        $cron_selected = htmlspecialchars( json_encode( $cron_maps[ 'map_' . $activeMapId ]['date_base'], JSON_HEX_QUOT ) );
                    }
                }
            }

            if ( ! $is_transfer_allowed ) {
                $cron_status = '';
            }

            $all_columns      = $decodedMap['selects'];
            $excluded_columns = ! empty( $decodedMap['excludes'] ) ? $decodedMap['excludes'] : false;

            if ( $excluded_columns ) {
                $map_columns = array_diff( $all_columns, $excluded_columns );
            } else {
                $map_columns = $all_columns;
            }
            ?>

            <input type="hidden" class="mapping"
                   value='<?php echo ! empty( $api ) ? json_encode( $api ) : ''; ?>'
                   data-prev_value=''
                   data-new_value=''
            >

            <div id="map-to-api__container">
                <div id="map-to-api__header">
                    <h3 class="title">
                        <span class="dashicons dashicons-clock<?php echo $cron_status ?>" title="<?php echo $cron_title ?>"></span>
                        <?php echo stripslashes( $activeMap->name ) ?>
                    </h3>

                    <div class="buttons-holder">
                        <a href="?page=wp2l-admin&tab=map_to_api" class="button button-primary">
                            <?php _e( 'Exit Map', 'wp2leads' ) ?>
                        </a>

                        <?php
                        $class = 'secondary';
                        $args  = array( 'disabled' => 'disabled' );

                        if ( $is_transfer_allowed ) {
                            $class = 'primary';
                            $args  = array(
                                'data-active-map'    => $activeMapId,
                                'data-cron-checked'  => $cron_checked,
                                'data-cron-selected' => $cron_selected,
                            );
                        }

                        ?>
                        <button id="btnUpdateMapToApi" class="button button-primary">
                            <?php echo __( 'Save and Exit', 'wp2leads' ); ?>
                        </button>

                        <button id="btnTransferData" class="button button-primary">
                            <?php echo __( 'Save and Transfer', 'wp2leads' ); ?>
                        </button>

                        <?php
                        if ( Wp2leads_License::is_action_allowed( 'duplicate_map' ) ) {
                            ?>
                            <a id="btnDuplicateMap" class="button button-primary"
                               href="?page=wp2l-admin&tab=map_builder&duplicate_mapping=<?php echo $activeMap->id ?>"
                            >
                                <?php _e( 'Duplicate Map', 'wp2leads' ) ?>
                            </a>
                            <?php
                        }
                        ?>
                        <button id="btnShowMapToApiList" class="button button-primary"
                            data-open-text="<?php echo __( 'Show map list', 'wp2leads' ); ?>"
                            data-close-text="<?php echo __( 'Hide map list', 'wp2leads' ); ?>"
                        >
                            <?php echo __( 'Show map list', 'wp2leads' ); ?>
                        </button>
                    </div>
                </div>

                <div id="map-to-api__body">
                    <div id="map-to-api__map-list">
                        <?php require_once dirname( __FILE__ ) . '/wp2leads-admin-runner-map-list.php'; ?>
                    </div>

                    <div id="map-to-api__left-column">

                        <div class="map2api_body">
                            <div class="available_options wp2leads-sticky">
                                <?php
                                ob_start();
                                include_once 'ajax/available_options_page_empty.php';
                                $available_options = ob_get_clean();
                                echo $available_options;
                                ?>
                            </div>
                        </div>
                    </div>
                    <div id="map-to-api__right-column">
                        <div class="map2api_side">
                            <div class="api_fields_container">
                                <?php if ( $logged_in ): ?>
                                    <div class="accordion-group">
                                        <h3 class="accordion-header active"><?php _e( 'Overview', 'wp2leads' ) ?></h3>

                                        <div class="accordion-body api-processing-holder"
                                             style="display: block">
                                            <h3 class="accordion-subheader"><?php _e( 'Active Opt-In Process:', 'wp2leads' ) ?></h3>

                                            <div id="active-optin-holder"
                                                 class="active-optin accordion-subbody">
                                                <div class="active-optin-wrapper"></div>
                                            </div>

                                            <h3 class="accordion-subheader">
                                                Already exiting Tags for this E-Mail Address (received from
                                                Klick-Tipp):<br>
                                                (Click on x near the tag, to untag the tag for this user
                                                instantly in Klick-Tipp)
                                            </h3>

                                            <div id="existed-tags-holder" class="accordion-subbody">
                                                <div class="existed-tags-wrapper"></div>
                                            </div>

                                            <h3 class="accordion-subheader" style="display: none">
                                                <?php _e( 'Possible Tags from current set of data:', 'wp2leads' ) ?>
                                            </h3>

                                            <div id="selected-tags-holder" class="accordion-subbody"
                                                 style="display: none">
                                                <div class="selected-tags-wrapper"></div>
                                            </div>

                                            <h3 class="accordion-subheader">
                                                <?php _e( 'Possible Tags from current set of data:', 'wp2leads' ) ?>
                                            </h3>

                                            <div id="selected-tags-holder" class="accordion-subbody">
                                                <div class="selected-tags-cloud-wrapper"></div>
                                                <br>
                                                <hr>
                                                <div class="selected-tags-cloud-legend">
                                                    <h3><?php _e( 'Legend:', 'wp2leads' ) ?></h3>
                                                    <p><span class="selected-tag-kt-legend">Tag on KT</span> -
                                                        Tag already on Klick Tipp</p>
                                                    <p><span class="selected-tag-kt-manual">Map Tag on KT</span>
                                                        - Tag already on Klick Tipp and in current map settings
                                                    </p>
                                                    <p><span class="selected-tag-kt-detach">Tag to Detach</span>
                                                        - Tag already on Klick Tipp but will be detached after
                                                        transfering data</p>
                                                    <p><span class="selected-tag-kt-new">New Tag</span> - Tag
                                                        not on Klick Tipp, but will be added after transfering
                                                        data</p>
                                                </div>
                                            </div>

                                            <div class="api-spinner-holder api-processing">
                                                <div class="api-spinner"></div>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="accordion-group">
                                        <h3 class="accordion-header strict"><?php _e( 'Opt-In', 'wp2leads' ) ?></h3>

                                        <div class="accordion-body">
                                            <h3 class="accordion-subheader">
                                                <?php _e( 'Default Opt-In Process:', 'wp2leads' ) ?>
                                            </h3>

                                            <div class="accordion-subbody">
                                                <div class="api-optins-wrapper">
                                                    <select class="optins-list" class="form-control">
                                                        <?php
                                                        foreach ( $optins as $key => $optin ) { ?>
                                                            <option value="<?php echo $key ?>" <?php echo $key == $api['default_optin'] ? 'selected' : ''; ?>>
                                                                <?php echo $optin ? $optin : __( 'Default Opt-In Process', 'wp2leads' ); ?>
                                                            </option>
                                                        <?php } ?>
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="optins-conditions-wrapper">
                                                <h3 class="accordion-subheader"><?php _e( 'Conditions', 'wp2leads' ) ?>
                                                    :</h3>

                                                <div class="accordion-subbody">
                                                    <div class="conditions-list"
                                                         data-saved-value='<?php echo isset( $api['conditions']['optins'] ) ? json_encode( $api['conditions']['optins'], JSON_FORCE_OBJECT ) : ''; ?>'></div>
                                                    <a href="#" class="button add_new_condition"
                                                       data-type="optins">&plus; Add</a>
                                                </div>
                                            </div>
                                        </div>

                                        <h3 class="accordion-header strict"><?php _e( 'Fields', 'wp2leads' ) ?></h3>

                                        <div class="accordion-body">
                                            <div id="inputFiledSearchKT">
                                                <input style="width: 100%; margin: 10px 0px;" type="text"
                                                       placeholder="Enter Field name">
                                            </div>

                                            <div class="api-fields-wrapper">
                                                <div class="api_field_box">
                                                    <div class="api_field_head">
                                                        <p class="field_label"><?php _e( 'Email', 'wp2leads' ) ?></p>
                                                        <p class="field_value"><?php _e( 'Choose an option', 'wp2leads' ) ?></p>
                                                    </div>

                                                    <div class="api_field_body">
                                                        <fieldgroup id="api_email">
                                                            <?php
                                                            $api_options = ! empty( $api['fields']['api_email'] ) ? ! is_array( $api['fields']['api_email'] ) ? array( $api['fields']['api_email'] ) : $api['fields']['api_email'] : [];
                                                            ?>
                                                            <select class="api-field" name="api_email" multiple
                                                                    data-api-option='<?php echo json_encode( $api_options, JSON_FORCE_OBJECT ); ?>'></select>
                                                        </fieldgroup>
                                                    </div>

                                                    <div class="api-field__value"></div>
                                                </div>

                                                <?php foreach ( $fields as $fieldName => $fieldDescription ): ?>
                                                    <div class="api_field_box">
                                                        <div class="api_field_head">
                                                            <p class="field_label"><?php _e( $fieldDescription, 'wp2leads' ) ?></p>
                                                            <p class="field_value"><?php _e( 'Choose an option', 'wp2leads' ) ?></p>
                                                        </div>

                                                        <div class="api_field_body">
                                                            <fieldgroup id="api_<?php echo( $fieldName ) ?>">
                                                                <?php
                                                                $type          = $api['fields'][ 'api_' . $fieldName ]['type'];
                                                                $api_options   = ! empty( $api['fields'][ 'api_' . $fieldName ] ) ? ! is_array( $api['fields'][ 'api_' . $fieldName ] ) ? array( $api['fields'][ 'api_' . $fieldName ] ) : $api['fields'][ 'api_' . $fieldName ] : [];
                                                                $table_columns = ! empty( $api_options['table_columns'] ) ? $api_options['table_columns'] : array();
                                                                ?>
                                                                <select
                                                                        class="api-field"
                                                                        name="api_<?php echo( $fieldName ) ?>"
                                                                        multiple
                                                                        data-api-option='<?php echo json_encode( $api_options, JSON_FORCE_OBJECT ); ?>'
                                                                ></select>
                                                                <select class="field-type">
                                                                    <option value="text" <?php echo 'text' === $type ? 'selected' : ''; ?>>
                                                                        text
                                                                    </option>
                                                                    <option value="number" <?php echo 'number' === $type ? 'selected' : ''; ?>>
                                                                        number
                                                                    </option>
                                                                    <option value="url" <?php echo 'url' === $type ? 'selected' : ''; ?>>
                                                                        url
                                                                    </option>
                                                                    <option value="date" <?php echo 'date' === $type ? 'selected' : ''; ?>>
                                                                        date
                                                                    </option>
                                                                    <option value="time" <?php echo 'time' === $type ? 'selected' : ''; ?>>
                                                                        time
                                                                    </option>
                                                                </select>
                                                            </fieldgroup>
                                                        </div>

                                                        <div class="api-field__value"></div>
                                                    </div>
                                                <?php endforeach; ?>
                                            </div>
                                        </div>

                                        <hr>

                                        <h3><?php _e( 'Tags', 'wp2leads' ) ?></h3>

                                        <?php
                                        $global_tag_prefixe = get_option('wp2l_klicktipp_tag_prefix');
                                        ?>

                                        <p class="globalTagPrefix__holder">
                                            <label for="globalTagPrefix"><?php echo __('Global Tag Prefix', 'wp2leads'); ?></label>
                                            <input id="globalTagPrefix"
                                                   type="text"
                                                   value="<?php echo !empty($global_tag_prefixe) ? $global_tag_prefixe : '' ?>"
                                                   data-selected-value="<?php echo !empty($global_tag_prefixe) ? $global_tag_prefixe : '' ?>"
                                                   class="form-control">
                                            <span><small><i><?php echo __('Example:', 'wp2leads'); ?></i> <strong>web1</strong></small></span>
                                        </p>

                                        <p id="mapTagPrefix__holder">
                                            <label for="mapTagPrefix"><?php echo __('Map Tag Prefix', 'wp2leads'); ?></label>
                                            <input id="mapTagPrefix"
                                                   type="text"
                                                   value="<?php echo !empty($api['tags_prefix']) ? $api['tags_prefix'] : '' ?>"
                                                   data-selected-value="<?php echo !empty($api['tags_prefix']) ? $api['tags_prefix'] : '' ?>"
                                                   class="form-control">
                                            <span><small><i><?php echo __('Map Tag Prefix has higher priority', 'wp2leads'); ?></i></small></span><br>
                                            <span><small><i><?php echo __('Example:', 'wp2leads'); ?></i> <strong>web1_form1</strong></small></span>
                                        </p>

                                        <?php
                                        if (empty($global_tag_prefixe) && empty($api['tags_prefix'])) {
                                            ?>
                                            <p class="warning-text tagPrefixWarning__noprefix">
                                                <span>
                                                    <i>
                                                        <?php _e('If you ever want to connect more than one website with same, similar tags please choose a prefix (f.e. <strong>web1</strong>). So the tags are clean separated.', 'wp2leads'); ?>
                                                    </i>
                                                </span>
                                            </p>
                                            <?php
                                        }
                                        ?>

                                        <h3 class="accordion-header strict"><?php _e( 'Add Tags', 'wp2leads' ) ?></h3>

                                        <div class="accordion-body">
                                            <h3 class="accordion-subheader"><?php _e( 'Tags to add when the lead is transferred:', 'wp2leads' ) ?></h3>

                                            <div class="accordion-subbody">
                                                <div class="create-tag-wrapper">
                                                    <input type="text" value=""
                                                           placeholder="Filter and create Tags"
                                                           class="tag-text">
                                                    <button id="create-tag"
                                                            class="button button-primary"><?php echo _e( 'Create tag', 'wp2leads' ); ?></button>
                                                </div>

                                                <div class="tags-wrapper">
                                                    <div id="tags-cloud-options" class="tags-cloud"
                                                         data-tags-cloud='<?php echo json_encode( $tags, JSON_FORCE_OBJECT ) ?>'>
                                                        <?php
                                                        $manually_selected_tags = isset( $api['manually_selected_tags']['tag_ids'] ) ? $api['manually_selected_tags']['tag_ids'] : array();

                                                        foreach ( $tags as $tag_code => $tag_name ) {
                                                            ?>
                                                            <fieldset>
                                                                <input
                                                                    <?php echo in_array( $tag_code, $manually_selected_tags ) ? 'checked' : ''; ?>
                                                                        id="<?php echo $tag_code; ?>"
                                                                        type="checkbox"
                                                                        value="<?php echo $tag_name; ?>"
                                                                        data-name="<?php echo $tag_name; ?>"
                                                                >
                                                                <label for="<?php echo $tag_code; ?>"><?php echo $tag_name; ?></label>
                                                            </fieldset>
                                                            <?php
                                                        }
                                                        ?>
                                                    </div>
                                                </div>
                                            </div>

                                            <div class="connected-options-wrapper">
                                                <h3 class="accordion-subheader"><?php echo _e( 'Automatic create tags and attach to Klick-Tipp user:', 'wp2leads' ); ?></h3>

                                                <div class="accordion-subbody">
                                                    <div
                                                            class="separators-list"
                                                            data-saved-value='<?php echo isset( $api['connected_for_tags']['separators'] ) ? json_encode( $api['connected_for_tags']['separators'], JSON_FORCE_OBJECT ) : ''; ?>'
                                                    ></div>

                                                    <a href="javascript:void(0);"
                                                       class="button add_new_separator">&plus; Add separator</a>

                                                    <?php
                                                    $api_options        = ! empty( $api['connected_for_tags']['tags'] ) ? ! is_array( $api['connected_for_tags']['tags'] ) ? array( $api['connected_for_tags']['tags'] ) : $api['connected_for_tags']['tags'] : array();
                                                    $api_options_concat = ! empty( $api['connected_for_tags']['tags_concat'] ) ? ! is_array( $api['connected_for_tags']['tags_concat'] ) ? array( $api['connected_for_tags']['tags_concat'] ) : $api['connected_for_tags']['tags_concat'] : array();
                                                    $unique_paths       = $map_columns;
                                                    ?>

                                                    <select class="options-list" multiple
                                                            data-saved-value='<?php echo ! empty( $api_options ) ? json_encode( $api_options, JSON_FORCE_OBJECT ) : ''; ?>'>
                                                        <?php

                                                        if ( false ) {
                                                            foreach ( $unique_paths as $table_column ):
                                                                ?>
                                                                <option value='<?php echo $table_column; ?>' <?php if ( in_array( $table_column, $api_options ) )
                                                                    echo 'selected' ?>><?php echo $table_column; ?></option>
                                                            <?php
                                                            endforeach;
                                                        } ?>
                                                    </select>

                                                    <h3><?php echo _e( 'For concatenated values:', 'wp2leads' ); ?></h3>

                                                    <select class="options-concat-list" multiple
                                                            data-saved-value='<?php echo ! empty( $api_options_concat ) ? json_encode( $api_options_concat, JSON_FORCE_OBJECT ) : ''; ?>'>
                                                        <?php
                                                        if ( false ) {
                                                            foreach ( $unique_paths as $table_column ):
                                                                ?>
                                                                <option value='<?php echo $table_column; ?>' <?php if ( in_array( $table_column, $api_options_concat ) )
                                                                    echo 'selected' ?>><?php echo $table_column; ?></option>
                                                            <?php
                                                            endforeach;
                                                        }
                                                        ?>
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="tags-conditions-wrapper">
                                                <h3 class="accordion-subheader"><?php _e( 'Conditions', 'wp2leads' ) ?>
                                                    :</h3>

                                                <div class="accordion-subbody">
                                                    <div
                                                            class="conditions-list"
                                                            data-saved-value='<?php echo isset( $api['conditions']['tags'] ) ? json_encode( $api['conditions']['tags'], JSON_FORCE_OBJECT ) : ''; ?>'
                                                    ></div>

                                                    <a href="javascript:void(0);"
                                                       class="button add_new_condition" data-type="tags">&plus;
                                                        Add</a>
                                                </div>
                                            </div>
                                        </div>

                                        <h3 class="accordion-header strict"><?php _e( 'Untag Tags', 'wp2leads' ) ?></h3>

                                        <div class="accordion-body">
                                            <div class="detach-tags-wrapper">
                                                <h3 class="accordion-subheader"><?php _e( 'Tags to detach:', 'wp2leads' ) ?></h3>

                                                <div class="accordion-subbody">
                                                    <input type="text" value="" placeholder="Filter tags..."
                                                           class="tag-text">
                                                    <button id="select-all-for-detach"
                                                            class="button button-primary"><?php echo _e( 'Select all', 'wp2leads' ); ?></button>
                                                    <button id="deselect-all-for-detach"
                                                            class="button button-primary"><?php echo _e( 'Deselect all', 'wp2leads' ); ?></button>

                                                    <div class="detach-tags-wrapper-selection">
                                                        <?php
                                                        $detach_tags = isset( $api['detach_tags']['tag_ids'] ) ? $api['detach_tags']['tag_ids'] : array();

                                                        foreach ( $tags as $tag_code => $tag_name ) { ?>
                                                            <fieldset>
                                                                <input <?php echo in_array( $tag_code, $detach_tags ) ? 'checked' : ''; ?>
                                                                        id="detach_<?php echo $tag_code; ?>"
                                                                        type="checkbox"
                                                                        value="<?php echo $tag_code; ?>"
                                                                        data-name="<?php echo $tag_name; ?>"
                                                                >
                                                                <label for="detach_<?php echo $tag_code; ?>"><?php echo $tag_name; ?></label>
                                                            </fieldset>
                                                        <?php } ?>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="tags-detach-conditions-wrapper">
                                                <h3 class="accordion-subheader"><?php _e( 'Conditions:', 'wp2leads' ) ?></h3>

                                                <div class="accordion-subbody">
                                                    <div class="conditions-list"
                                                         data-saved-value='<?php echo isset( $api['conditions']['detach_tags'] ) ? json_encode( $api['conditions']['detach_tags'], JSON_FORCE_OBJECT ) : ''; ?>'></div>
                                                    <a href="javascript:void(0);"
                                                       class="button add_new_detach_condition">&plus; Add</a>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                <?php else:
                                    $connector->get_last_error();
                                    ?>
                                    It is required to specify the correct data in the settings for KlickTipp
                                <?php endif; ?>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php endif; ?>
    </div>
<?php
$memory = ( memory_get_usage() / 1048576 );
?>