<?php
$wp2l_activation_in_progress = get_transient( 'wp2l_activation_in_progress' );
$wp2l_no_server_response = get_transient('wp2l_no_server_response');
$wp2l_last_paid_day_message = get_transient('wp2l_last_paid_day_message');
$wp2l_payment_issue_message = get_transient('wp2l_payment_issue_message');
$wp2l_payment_missed_message = get_transient('wp2l_payment_missed_message');
$wp2l_plugin_version_status = get_transient('wp2l_plugin_version_status');

if (false !== $wp2l_plugin_version_status) {
    if (-1 === (int) $wp2l_plugin_version_status) {
        ?>
        <div class="notice notice-error">
            <p>
                <strong><?php _e('WP2Leads', 'wp2leads') ?></strong>:
                <?php
                echo sprintf (
                    __('Your %s Version is outdated and stopped working! Please update the plugin: <a href="plugins.php?plugin_status=upgrade">Go to the update.</a>', 'wp2leads'),
                    WP2LEADS_VERSION
                );
                ?>
            </p>
        </div>
        <?php
    } elseif (0 === (int) $wp2l_plugin_version_status) {
        ?>
        <div class="notice notice-warning">
            <p>
                <strong><?php _e('WP2Leads', 'wp2leads') ?></strong>:
                <?php
                echo sprintf (
                    __('Your %s Version nearly outdated and will stopped working with the release of the next version! Please update the plugin: <a href="plugins.php?plugin_status=upgrade">Go to the update.</a>', 'wp2leads'),
                    WP2LEADS_VERSION
                );
                ?>
            </p>
        </div>
        <?php
    }
}

if ($wp2l_activation_in_progress) {
    ?>
    <div class="notice notice-warning wp2lead-notice notice-can-disable">
        <p>
            <strong><?php _e('WP2Leads', 'wp2leads') ?></strong>:
            <?php _e('Your activation is in progress. You need to Complete this to securely save your license data.', 'wp2leads') ?>
            <a href="?page=wp2l-admin&tab=settings"><?php _e('Open settings tab', 'wp2leads') ?></a>
        </p>
    </div>
    <?php
}

if ($wp2l_payment_missed_message) {
    ?>
    <div id="payment_missed_message" class="notice notice-warning wp2lead-notice notice-can-disable">
        <p>
            <strong><?php _e('WP2Leads', 'wp2leads') ?></strong>:
            <?php _e('The transfer of contacts stopped, because of an issue with payment. Please check your emails from support@digistore24.com!', 'wp2leads') ?>
            <button class="notice-disable"><?php _e('Dismiss this notice.', 'wp2leads') ?></button>
        </p>
    </div>
    <?php
}

if ($wp2l_payment_issue_message) {
    ?>
    <div id="payment_issue_message" class="notice notice-warning wp2lead-notice notice-can-disable">
        <p>
            <strong><?php _e('WP2Leads', 'wp2leads') ?></strong>:
            <?php _e('The transfer of contacts will stop soon, because of an issue with payment. Please check your emails from support@digistore24.com!', 'wp2leads') ?>
            <button class="notice-disable"><?php _e('Dismiss this notice.', 'wp2leads') ?></button>
        </p>
    </div>
    <?php
}


if ($wp2l_no_server_response) {
    ?>
    <div class="notice notice-error">
        <p>
            <strong><?php _e('WP2Leads', 'wp2leads') ?></strong>:
            <?php _e('In 24 hours your license will be removed completely (no server response). You can avoid that your license will be removed by following the instructions inside the email from support@digistore24.com!', 'wp2leads') ?>
        </p>
    </div>
    <?php
}
?>