<?php
/**
 * Created by PhpStorm.
 * Date: 2/4/18
 * Time: 8:37 AM
 */

$wp2l_license = get_option('wp2l_license');
$wp2l_activation_in_progress = get_transient( 'wp2l_activation_in_progress' );
?>

<h2><?php _e('Settings', 'wp2leads') ?></h2>

<hr>

<form>
    <table id="table-setting">
        <thead>
            <tr>
                <th colspan="2"><?php _e('Information about license', 'wp2leads') ?></th>
            </tr>
        </thead>

        <tbody>
            <tr>
                <td><?php _e('Email', 'wp2leads') ?></td>

                <td>
                    <input type="text" style="width: 100%;" id="wp2l-license-email" name="wp2l-license-email" class="form-control" value="<?php echo $wp2l_license['email']; ?>">
                </td>
            </tr>

            <tr>
                <td><?php _e('License key', 'wp2leads') ?></td>

                <td>
                    <input type="text" style="width: 100%;" id="wp2l-license-key" name="wp2l-license-key" class="form-control"
                           value="<?php echo $wp2l_activation_in_progress ? $wp2l_license['key'] : $wp2l_license['secured_key']; ?>"
                    >
                </td>
            </tr>

            <tr>
                <td></td>
                <td>
                    <button id="wp2lActivate" class="button button-primary" data-action="activation" type="button"><?php _e('Activate', 'wp2leads') ?></button>
                    <button id="wp2lDectivate" class="button button-primary" data-action="deactivation" type="button"><?php _e('Deactivate', 'wp2leads') ?></button>
                    <?php
                    if ($wp2l_activation_in_progress) {
                        ?>
                        <button class="button button-danger wp2lComplete" type="button"><?php _e('Close manage licenses', 'wp2leads') ?></button>
                        <?php
                    }
                    ?>
                </td>
            </tr>

            <?php
            if ($wp2l_activation_in_progress) {
                $site_list = Wp2leads_License::get_license_list();

                if ($site_list) {
                    ?>
                    <tr>
                        <td>List of sites</td>

                        <td>
                        <?php
                        if (is_array($site_list)) {
                            ?>
                            <table>
                                <tr>
                                    <td colspan="3">
                                        <p><?php echo __('Total licenses', 'wp2leads') ?>: <strong><?php echo  Wp2leads_License::count_licenses(); ?></strong></p>
                                        <p><?php echo __('Available licenses', 'wp2leads') ?>: <strong><?php echo  Wp2leads_License::count_licenses(false); ?></strong></p>
                                    </td>
                                </tr>
                            <?php
                            foreach ($site_list as $site) {
                                if ($site['site_url'] === Wp2leads_License::get_current_site()) {
                                    $status = __('Current', 'wp2leads');
                                    $current = true;
                                } else {
                                    $status = $site['status'] === '1' ? __('Active', 'wp2leads') : __('Disabled', 'wp2leads');
                                    $current = false;
                                }
                                ?>
                                <tr>
                                    <td style="padding: 5px;"><strong><?php echo $site['site_url'] ?></strong></td>
                                    <td style="padding: 5px;"><?php echo $status ?></td>
                                    <td style="padding: 5px;">
                                        <?php
                                        if (!$current) {
                                            ?>
                                            <button class="button wp2lRemove" data-site="<?php echo $site['site_url'] ?>" type="button">Remove</button>
                                            <?php
                                        }
                                        ?>
                                    </td>
                                </tr>
                                <?php
                            }
                            ?>
                            </table>
                            <?php
                        } else {
                            echo $site_list;
                        }
                        ?>
                        </td>
                    </tr>
                    <?php
                }
            }
            ?>

            <?php
            if (Wp2leads_License::is_dev_allowed()) {
                ?>
                <tr>
                    <td>Developer Mode</td>
                    <td>
                        <?php
                        // TODO - This block is only for DEV purposes - need to be romoved
                        ?>
                        License level: <strong class="license-level-current" style="display: inline-block;margin-right: 25px;">
                            <?php echo $wp2l_is_dev ? $dev_version : __('Dev Mode disabled', 'wp2leads'); ?>
                        </strong>

                        <button data-license="free" class="button change-license" type="button">Try Free</button>
                        <button data-license="essent" class="button change-license" type="button">Try Essential</button>
                        <button data-license="pro" class="button change-license" type="button">Try Pro</button>

                        <button data-license="reset" class="button change-license" type="button">Reset</button>
                        <?php
                        ?>
                    </td>
                </tr>
                <?php
            }
            ?>
        </tbody>
    </table>
    <table id="table-setting" style="margin-top: 20px;">
        <thead>
        <tr>
            <th colspan="2"><?php _e('Information about KlickTipp', 'wp2leads') ?></th>
        </tr>
        </thead>
        <tbody>
        <tr>
            <td><?php _e('Username', 'wp2leads') ?></td>
            <td><input style="width: 100%;" type="text" id="wp2l-settings-klicktipp-username" class="form-control" name="settings-klicktipp-username" value="<?php echo(get_option('wp2l_klicktipp_username')); ?>"></td>
        </tr>
        <tr>
            <td><?php _e('Password', 'wp2leads') ?></td>
            <td><input style="width: 100%;" type="password" id="wp2l-settings-klicktipp-password" class="form-control" name="settings-klicktipp-password" value="<?php echo(get_option('wp2l_klicktipp_password')); ?>"></td>
        </tr>
        <tr>
            <td></td>
            <td><input type="submit" name="btnKlicktippSubmit" id="btnKlicktippSubmit" class="button button-primary" value="Save"></td>
        </tr>
        </tbody>
    </table>

    <table id="table-setting" style="margin-top: 20px;">
        <thead>
            <tr>
                <th colspan="3"><?php _e('System information', 'wp2leads') ?></th>
            </tr>
        </thead>

        <tbody>
            <tr>
                <td><?php _e('WordPress Version', 'wp2leads') ?></td>
                <td><?php _e('>= 4.5.0 (latest best)', 'wp2leads') ?></td>
                <td><?php echo $system_info['wp_version'] ?></td>
            </tr>

            <tr>
                <td><?php _e('Wp2Leads Version', 'wp2leads') ?></td>
                <td><?php

                    if(empty($wp2l_plugin_allowed_versions['minActiveVersion']) || empty($wp2l_plugin_allowed_versions['activeVersion'])) {
                        echo __('unknown', 'wp2leads');
                    } else {
                        echo sprintf (
                            __('>= %s (%s latest)', 'wp2leads'),
                            $wp2l_plugin_allowed_versions['minActiveVersion'], $wp2l_plugin_allowed_versions['activeVersion']
                        );
                    }
                    ?></td>
                <td><?php echo $system_info['wp2lead_version'] ?></td>
            </tr>

            <tr>
                <td><?php _e('PHP Version', 'wp2leads') ?></td>
                <td><?php _e('>= 5.6 (WordPress recommends 7.0+)', 'wp2leads') ?></td>
                <td><?php echo $system_info['php_version'] ?></td>
            </tr>

            <tr>
                <td><?php _e('MySQL Version', 'wp2leads') ?></td>
                <td><?php _e('>= 5.6.0 (WordPress recommends 5.6+)', 'wp2leads') ?></td>
                <td><?php echo $system_info['mysql_version'] ?></td>
            </tr>

            <tr>
                <td><?php _e('PHP Memory Limit', 'wp2leads') ?></td>
                <td><?php _e('>= 64 MB (recomended >= 128 MB)', 'wp2leads') ?></td>
                <td><?php echo size_format($system_info['php_memory_limit']) ?></td>
            </tr>
        </tbody>
    </table>
</form>