<?php
/**
 * Created by PhpStorm.
 * User: oleksii.khodakivskyi
 * Date: 06.09.18
 * Time: 23:21
 */
?>

<h2><?php _e('Statistics', 'wp2leads') ?></h2>
<hr>

<?php
$statistics_list = StatisticsModel::getList();
$maps = StatisticsManager::getMaps();
?>
<div class="statistics-wrapper">
    <table id="statistics-table">
        <thead>
            <tr>
                <th><?php _e('Last transferred', 'wp2leads') ?></th>
                <th><?php _e('Map ID', 'wp2leads') ?></th>
                <th><?php _e('Transfer type', 'wp2leads') ?></th>
                <th><?php _e('Statistics of the transfer', 'wp2leads') ?></th>
            </tr>
        </thead>

        <tbody>
        <?php
        foreach ($statistics_list as $row) {
            $statistic = json_decode($row['statistics'], true);
            $local_date = StatisticsManager::convertTimeToLocal($row['time']);
            if (!empty($maps[$row['map_id']])) {
                ?>
                <tr>
                    <td class="date" data-title="<?php _e('Last transferred', 'wp2leads') ?>"><?php echo $local_date; ?></td>

                    <td class="map-id" data-title="<?php _e('Map ID', 'wp2leads') ?>">
                        <a href="?page=wp2l-admin&tab=map_to_api&active_mapping=<?php echo $row['map_id']?>">
                            <?php echo $row['map_id']?> - <?php echo $maps[$row['map_id']]['name']?>
                        </a>
                    </td>

                    <td class="transfer-type" data-title="<?php _e('Transfer type', 'wp2leads') ?>"><?php echo $row['transfer_type'] ?></td>

                    <td class="data" data-title="<?php _e('Statistics of the transfer', 'wp2leads') ?>">
                        <?php
                        foreach ($statistic as $key => $value) {
                            ?>
                            <div>
                                <span class="name"><?php echo $key ?></span> - <span class="value"><?php echo $value ?></span>
                            </div>
                            <?php
                        }
                        ?>
                    </td>
                </tr>
                <?php
            }
        }
        ?>
        </tbody>
    </table>
</div>
