<?php
/**
 * Created by PhpStorm.
 * User: oleksii.khodakivskyi
 * Date: 06.09.18
 * Time: 23:31
 */

class StatisticsModel {
    /**
     * Table name in the database
     *
     * @var string
     */
    private static $table_name = 'wp2leads_transfer_statistics';

    /**
     * Creating table schema on plugin activation
     */
    public static function createTableSchema() {
        global $wpdb;
        $table_name = $wpdb->prefix . self::$table_name;

        $charset_collate = $wpdb->get_charset_collate();

        $sql = "CREATE TABLE {$table_name} (
                    id mediumint(9) NOT NULL AUTO_INCREMENT,
                    time datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
                    map_id mediumint(9) NOT NULL,
                    statistics text NOT NULL,
                    transfer_type text NOT NULL,
                    PRIMARY KEY (id)
                    ) $charset_collate;";

        dbDelta($sql);
    }

    /**
     * Inserting new row to the table
     *
     * @param $data
     */
    public static function insert($data) {
        global $wpdb;

        $table_name = $wpdb->prefix . self::$table_name;

        $wpdb->insert(
            $table_name,
            $data
        );
    }

    /**
     * Returning all statistics information ordering by time DESC
     *
     * @return array|null|object
     */
    public static function getList() {
        global $wpdb;
        $table_name = $wpdb->prefix . self::$table_name;

        return $wpdb->get_results("SELECT * FROM {$table_name} ORDER BY time DESC", ARRAY_A);
    }

    public static function get($filter, $select) {
        global $wpdb;
        $table_name = $wpdb->prefix . self::$table_name;

        $sql = 'SELECT ';

        if (!empty($select)) {
            $sql .= implode(', ', $select);
        } else {
            $sql .= '*';
        }

        $sql .= ' FROM ' . $table_name . ' WHERE 1=1';

        if ( !empty( $filter ) ) {
            foreach ($filter as $key => $value) {
                $sql .= ' AND ' . $key . "='" . $value . "' ";
            }
        }

        $sql .= ' ORDER BY time DESC';

        return $wpdb->get_results($sql, ARRAY_A);
    }

    /**
     * Returning data filtered by conditions in $filter array and selecting only columns from $select or all
     *
     * @param $filter
     * @param $select
     * @return array|null|object
     */
    public static function getBy($filter, $select) {
        global $wpdb;
        $table_name = $wpdb->prefix . self::$table_name;

        $sql = 'SELECT ';

        if (!empty($select)) {
            $sql .= implode(', ', $select);
        } else {
            $sql .= '*';
        }

        $sql .= ' FROM ' . $table_name;

        if (!empty($filter)) {
            $sql .= ' WHERE 1=1 ';

            foreach ($filter as $code => $value) {
                $sql .= 'AND ' . $code . "='" . $value . "' ";
            }
        }

        $sql .= ' ORDER BY time DESC';

        return $wpdb->get_row($sql, ARRAY_A);
    }
}